| Status | Coverage | Docs |
| :----: | :----: | :----: |
| [![CI](https://github.com/mateuszbaran/CovarianceEstimation.jl/workflows/CI/badge.svg)](https://github.com/mateuszbaran/CovarianceEstimation.jl/actions?query=workflow%3ACI+branch%3Amaster) | [ ![codecov.io](http://codecov.io/github/mateuszbaran/CovarianceEstimation.jl/coverage.svg?branch=master)](http://codecov.io/github/mateuszbaran/CovarianceEstimation.jl?branch=master) | [![](https://img.shields.io/badge/docs-stable-blue.svg)](https://mateuszbaran.github.io/CovarianceEstimation.jl/stable) [![](https://img.shields.io/badge/docs-dev-blue.svg)](https://mateuszbaran.github.io/CovarianceEstimation.jl/dev) |

# CovarianceEstimation.jl

Lightweight robust covariance estimation in Julia i.e. if you have a data matrix `X` of size `n×p` corresponding to `n` observations with `p` features, this package will help you to obtain an estimator of the covariance matrix of size `p×p` associated with this data.

**Note**: if you are interested in covariance estimation in the context of a linear regression, consider for now the package [CovarianceMatrices.jl](https://github.com/gragusa/CovarianceMatrices.jl) which focuses around that case.

## Quick start

```julia
using CovarianceEstimation

X = randn(5, 7)

S_uncorrected  = cov(SimpleCovariance(), X)
S_corrected    = cov(SimpleCovariance(corrected=true), X)

# using linear shrinkage with different targets
LSE = LinearShrinkage
# - Ledoit-Wolf target + shrinkage
method = LSE(ConstantCorrelation())
S_ledoitwolf = cov(method, X)
# - Chen target + shrinkage (using the more verbose call)
method = LSE(target=DiagonalCommonVariance(), shrinkage=:rblw)
S_chen_rblw = cov(method, X)
method = LSE(target=DiagonalCommonVariance(), shrinkage=:oas)
S_chen_oas = cov(method, X)

# a pre-defined shrinkage can be used as well
method = LinearShrinkage(DiagonalUnitVariance(), 0.5)
# using a given shrinkage
S_05 = cov(method, X)
```

## Currently supported algorithms

In this section, `X` is the data matrix of size `n × p`, `S` is the sample covariance matrix with `S = κ (Xc' * Xc)` where `κ` is either `n` (uncorrected) or `n-1` (corrected) and `Xc` is the centred data matrix (see [docs](https://mateuszbaran.github.io/CovarianceEstimation.jl/dev)).

* `SimpleCovariance`: basic corrected or uncorrected sample covariance (implemented in `StatsBase.jl`).

**Time complexity**: `O(p²n)` with a low constant

### Sample covariance based methods

These methods build an estimator of the covariance derived from `S`. They are implemented using abstract covariance estimation interface from `StatsBase.jl`.

* `LinearShrinkage`: James-Stein type estimator of the form `(1-λ)S+λF` where `F` is a target and `λ∈[0,1]` a shrinkage intensity.
  - common targets are implemented following the taxonomy given in [**1**] along with Ledoit-Wolf optimal shrinkage intensities [**2**].
  - in the case of the `DiagonalCommonVariance` target, a Rao-Blackwellised Ledoit-Wolf shrinkage (`:rblw`) and Oracle-Approximating shrinkage (`:oas`) are also supported (see [**3**]).
  - **Note**: `S` is symmetric semi-positive definite so that if the `F` is symmetric positive definite and provided `λ` is non-zero, the estimator obtained after shrinkage is also symmetric positive definite. For the diagonal targets `DiagonalUnitVariance`, `DiagonalCommonVariance` and `DiagonalUnequalVariance` the target is necessarily SPD.
* `AnalyticalNonlinearShrinkage`: estimator of the form `MΛM'` where `M` and `Λ` are matrices derived from the eigen decomposition of `S`.[**4**]
* `BiweightMidcovariance`: robust estimator, described more in the [documentation](https://mateuszbaran.github.io/CovarianceEstimation.jl/dev/man/methods/#Biweight-midcovariance).[**5**]

**Time complexity**:
- Linear shrinkage: `O(p²n)` with a low constant (main cost is forming `S`)
- Nonlinear shrinkage:
  * if `p<n`: `O(p²n + n²)` with a moderate constant (main cost is forming `S` and manipulating a matrix of `n²` elements)
  * if `p>n`: `O(p³)` with a low constant (main cost is computing the eigen decomposition of `S`).
- Biweight midcovariance: `O(p²n)`

### Other estimators (coming)

These are estimators that may be implemented in the future, see also [this review  paper](https://arxiv.org/pdf/1504.02995.pdf).

* Sparsity based estimators for either the covariance or the precision
* Rank based approaches
* [POET](https://arxiv.org/pdf/1201.0175.pdf)
* HAC
* ...

For HAC (and other estimators of covariance of coefficient of regression models) you can currently use the [CovarianceMatrices.jl](https://github.com/gragusa/CovarianceMatrices.jl) package.

## Comparison to existing libraries

Rough benchmarks are run over random matrices of various sizes (`40x20, 20x40, 400x200, 200x400`).
These benchmarks should (as usual) be taken with a pinch of salt but essentially a significant speedup should be expected for a standard problem.

* **Sklearn** (implements `DiagonalCommonVariance` target with `oas` and `lw` shrinkage)
  - average speedup: `5x`
* **Corpcor** (implements `DiagonalUnequalVariance` target with `ss` shrinkage)
  - average speedup: `22x`
* **Ledoit-Wolf 1** (implements `ConstantCorrelation` target with `lw` shrinkage, we used Octave for the comparison)
  - average speedup: `12x`
* **Ledoit-Wolf 2** (implements `AnalyticalNonlinearShrinkage`)
  - average speedup: `25x`
* **Astropy** (implements `BiweightMidcovariance`)
  - average speedup: `3x`


## References

* [**1**] J. Schäfer and K. Strimmer, *[A Shrinkage Approach to Large-Scale Covariance Matrix Estimation and Implications for Functional Genomics](https://strimmerlab.github.io/publications/journals/shrinkcov2005.pdf)*, Statistical Applications in Genetics and Molecular Biology, 2005.
* [**2**] O. Ledoit and M. Wolf, *[Honey, I Shrunk the Sample Covariance Matrix](http://www.ledoit.net/honey.pdf)*, The Journal of Portfolio Management, 2004.
* [**3**] Y. Chen, A. Wiesel, Y. C. Eldar, and A. O. Hero, *[Shrinkage Algorithms for MMSE Covariance Estimation](https://arxiv.org/pdf/0907.4698.pdf)*, IEEE Transactions on Signal Processing, 2010.
* [**4**] O. Ledoit and M. Wolf, *[Analytical Nonlinear Shrinkage of Large-Dimensional Covariance Matrices](http://www.econ.uzh.ch/static/wp/econwp264.pdf)*, Working Paper, 2018.
* [**5**] Beers, Flynn, and Gebhardt (1990; AJ 100, 32) "Measures of Location and Scale for Velocities in Clusters of Galaxies – A Robust Approach"

function _test_cov_vec(ce::CovarianceEstimator, X::AbstractMatrix{<:Real})
    c = cov(ce, X)
    @inbounds for i in 1:size(X, 2)
        @test cov(ce, @view(X[:, i])) ≈ c[i, i] atol = 1e-12 rtol = 1e-16
    end
end

function _test_cov_vecvec(ce::CovarianceEstimator, X::AbstractMatrix{<:Real})
    c = cov(ce, X)
    @inbounds for i in 1:size(X, 2)
        for j in 1:size(X, 2)
            cij = cov(ce, @view(X[:, i]), @view(X[:, j]))
            @test cij ≈ c[i, j] atol = 1e-12 rtol = 1e-16
        end
    end
end

@testset "BiweightMidcovariance" begin
    for c in (9, 5)
        for modify_sample_size in (true, false)
            @testset "basic properties c=$c, modify_sample_size=$modify_sample_size" begin
                ce = BiweightMidcovariance(; c=c, modify_sample_size=modify_sample_size)
                for X in test_matrices
                    testTransposition(ce, X)
                    testDims(ce, X)
                    testUncorrelated(ce)
                    testTranslation(ce, X)

                    # Test that other dispatches are consistent with the one tested above.
                    _test_cov_vec(ce, X)
                    _test_cov_vecvec(ce, X)
                end
            end
        end
    end

    @testset "Z should give zeros, not NaNs" begin
        # This covers a difference discovered against astropy.
        # It was due to not implementing the special case that covariance is defined to be 0
        # when MAD = 0.
        @test cov(BiweightMidcovariance(), Z) == zeros(Float64, 3, 3)
    end

    @testset "astropy reference (c=9.0)" begin
        # These tests are against references generated with astropy.
        #
        # References generated with:
        #   * System: Linux 5.4.0-90-generic, x86_64, Intel 8700K
        #   * Software: Python 3.7.6, astropy 4.3.1, numpy 1.21.2
        #
        # import os
        # import numpy
        # from astropy.stats import biweight_midcovariance
        # prefix = os.path.join(
        #     os.path.expanduser("~"), ".julia", "dev", "CovarianceEstimation", "test",
        #     "test_matrices"
        # )
        # for sample in ["20x100", "50x50", "100x20", "50x50tdist3"]:
        #     for modify_sample_size in [False, True]:
        #         path = os.path.join(prefix, f"{sample}.csv")
        #         X = numpy.genfromtxt(path).T
        #         c = biweight_midcovariance(X, modify_sample_size=modify_sample_size)
        #         mss = "_mss" if modify_sample_size else ""
        #         out_path = os.path.join(prefix, f"{sample}_bwcov{mss}.csv")
        #         with open(out_path, "w") as file_:
        #             for i in range(c.shape[0]):
        #                 file_.write(" ".join(str(el) for el in c[i, :]))
        #                 file_.write("\n")
        names = ["20x100", "50x50", "100x20", "50x50tdist3"]
        _test_refs(BiweightMidcovariance(), names, "bwcov")
        _test_refs(BiweightMidcovariance(; modify_sample_size=true), names, "bwcov_mss")
    end
end

require(corpcor)
require(matrixcalc)

C_20 = as.matrix(read.table("tmpmat/C_20.csv"))
C_40 = as.matrix(read.table("tmpmat/C_40.csv"))
C_200 = as.matrix(read.table("tmpmat/C_200.csv"))
C_400 = as.matrix(read.table("tmpmat/C_400.csv"))

X_40x20   = as.matrix(read.table('tmpmat/X_40x20.csv'))
X_20x40   = as.matrix(read.table('tmpmat/X_20x40.csv'))
X_400x200 = as.matrix(read.table('tmpmat/X_400x200.csv'))
X_200x400 = as.matrix(read.table('tmpmat/X_200x400.csv'))

C = list(C_20, C_40, C_200, C_400)
X = list(X_40x20, X_20x40, X_400x200, X_200x400)

times = numeric(4)
res = numeric(4)

for (i in c(1, 2, 3, 4)){
  Xi = X[[i]]
  Ci = C[[i]]
  start = Sys.time()
  C_est = cov.shrink(Xi, lambda.var=0.0)
  times[i] = as.numeric(Sys.time()-start)
  res[i] = frobenius.norm(C_est - Ci)
}

module CovarianceEstimation

using Statistics
using StatsBase
using LinearAlgebra
import StatsBase: cov
using WoodburyMatrices
using TSVD

export cov
export CovarianceEstimator, SimpleCovariance,
    LinearShrinkage,
    # Targets for linear shrinkage
    DiagonalUnitVariance, DiagonalCommonVariance, DiagonalUnequalVariance,
    CommonCovariance, PerfectPositiveCorrelation, ConstantCorrelation,
    # Eigendecomposition-based methods
    AnalyticalNonlinearShrinkage,
    # Biweight midcovariance
    BiweightMidcovariance,
    # Woodbury-based methods
    WoodburyEstimator,
    # Loss functions
    NormLossCov, StatLossCov


include("utils.jl")
include("loss.jl")
include("biweight.jl")
include("linearshrinkage.jl")
include("nonlinearshrinkage.jl")
include("woodbury.jl")

end # module

# Nonlinear shrinkage estimation can be described in terms of a loss function measuring the error between
# the target and the sample eigenvalues. In:
#    Donoho, D.L., Gavish, M. and Johnstone, I.M., 2018.
#    Optimal shrinkage of eigenvalues in the spiked covariance model. Annals of statistics, 46(4), p.1742.
# there is a systematic analysis of different loss functions; their classification scheme is encoded here.

# Implementation note:
# While we could parametrize all these different loss functions in the type system and use dispatch,
# that would induce needless specialization: every function that took a `LossFunction` would have to be
# specialized, even if the the argument encoding the loss function is merely "passed-through."
# So instead, we hide details from the type system, dividing the Donoho classification scheme into just two types,
# `NormLossCov` and `StatLossCov`, and use a fast runtime check to determine which shrinkage function to use.

abstract type LossFunction end

"""
    NormLossCov(norm::Symbol, pivotidx::Int)

Specify a loss function for which the estimated covariance will be optimal. `norm` is one of
`:L1`, `:L2`, or `:Linf`, and `pivotidx` is an integer from 1 to 7, as specified in Table 1 (p. 1755)
of Donoho et al. (2018). In the table below, `A` and `B` are the target and sample covariances,
respectively, and the loss function is the specified norm on the quantity in the `pivot` column:

| `pivotidx` | `pivot` | Notes |
|------------|---------|-------|
| 1          | `A - B`     | |
| 2          | `A⁻¹ - B⁻¹`     | |
| 3          | `A⁻¹ B - I`     | Not available for `:L1` |
| 4          | `B⁻¹ A - I`     | Not available for `:L1` |
| 5          | `A⁻¹ B + B⁻¹ A - 2I` | Not supported |
| 6          | `sqrt(A) \\ B / sqrt(A) - I` | |
| 7          | `log(sqrt(A) \\ B / sqrt(A))` | Not supported |

See also [`StatLossCov`](@ref).

Reference:
    Donoho, D.L., Gavish, M. and Johnstone, I.M., 2018.
    Optimal shrinkage of eigenvalues in the spiked covariance model. Annals of statistics, 46(4), p.1742.
"""
struct NormLossCov <: LossFunction
    # Lᴺᴷ where N is the norm and K is an integer (1 through 7) representing the pivot function
    norm::Symbol
    pivotidx::Int

    function NormLossCov(norm::Symbol, pivotidx::Int)
        norm ∈ (:L1, :L2, :Linf) || throw(ArgumentError("norm must be :L1, :L2, or :Linf"))
        1 <= pivotidx <= 7 || throw(ArgumentError("pivotidx must be from 1 to 7 (see Table 1 in Donoho et al. (2018))"))
        return new(norm, pivotidx)
    end
end

"""
    StatLossCov(mode::Symbol)

Specify a loss function for which the estimated covariance will be optimal. `mode` is one of
`:st`, `:ent`, `:div`, `:aff`, or `:fre`, as specified in Table 2 (p. 1757) of Donoho et al. (2018).
In the table below, `A` and `B` are the target and sample covariances, respectively:

| `mode` | loss |  Interpretation  |
|--------|---------|-----|
| `:st`  | `st(A, B) = tr(A⁻¹ B - I) - log(det(B)/det(A))` | Minimize `2 Dₖₗ(N(0, B)||N(0, A))` where `N` is normal distribution |
| `:ent` | `st(B, A)` | Minimize errors in Mahalanobis distances |
| `:div` | `st(A, B) + st(B, A)` | |
| `:aff` | `0.5 * log(det(A + B) / (2 * sqrt(det(A*B))))` | Minimize Hellinger distance between `N(0, A)` and `N(0, B)` |
| `:fre` | `tr(A + B - 2sqrt(A*B))` | |
"""
struct StatLossCov <: LossFunction
    mode::Symbol

    function StatLossCov(mode::Symbol)
        statlosses = (:st, :ent, :div, :aff, :fre)

        mode ∈ statlosses || throw(ArgumentError("mode must be among $(statlosses)"))
        return new(mode)
    end
end


# Implement Table 2, Donoho et al. (2018), p. 1757

function shrinker(loss::NormLossCov, ℓ::Real, c::Real, s::Real)
    # See top of file for why these are branches rather than dispatch
    norm, pivotidx = loss.norm, loss.pivotidx
    pivotidx ∈ (5, 7) && throw(ArgumentError("Pivot index $(pivotidx) is not supported, see Table 2 in Donoho et al. 2018"))
    if norm == :L2         # Frobenius
        return  pivotidx == 1 ? ℓ * c^2 + s^2 :
                pivotidx == 2 ? ℓ / (c^2 + ℓ * s^2) :
                pivotidx == 3 ? (ℓ * c^2 + ℓ^2 * s^2) / (c^2 + ℓ^2 * s^2) :
                pivotidx == 4 ? (ℓ^2 * c^2 + s^2) / (ℓ * c^2 + s^2) :
                #= pivotidx == 6 =# 1 + (ℓ - 1) * c^2 / (c^2 + ℓ * s^2)^2
    elseif norm == :Linf   # Operator
        pivotidx ∈ (3, 4) && throw(ArgumentError("Pivot index $(pivotidx) is not supported for Linf norm, see Table 2 in Donoho et al. 2018"))
        return  pivotidx ∈ (1, 2) ? ℓ :
                #= pivotidx == 6 =# 1 + (ℓ - 1) / (c^2 + ℓ * s^2)
    elseif norm == :L1     # Nuclear
        val = pivotidx == 1 ? 1 + (ℓ - 1) * (1 - 2s^2) :
              pivotidx == 2 ? ℓ / (c^2 + (2ℓ-1)*s^2) :
              pivotidx == 3 ? ℓ / (c^2 + ℓ^2*s^2) :
              pivotidx == 4 ? (ℓ^2*c^2 + s^2) / ℓ :
              #= pivotidx == 6 =# (ℓ - (ℓ - 1)^2*c^2*s^2) / (c^2 + ℓ*s^2)^2
        return max(val, 1)
    end
    throw(ArgumentError("Norm $(norm) is not supported"))
end

function shrinker(loss::StatLossCov, ℓ::Real, c::Real, s::Real)
    mode = loss.mode
    if mode == :st
        return ℓ / (c^2 + ℓ * s^2)
    elseif mode == :ent
        return ℓ * c^2 + s^2
    elseif mode == :div
        return sqrt((ℓ^2 * c^2 + ℓ * s^2) / (c^2 + ℓ * s^2))
    elseif mode == :fre
        return (sqrt(ℓ) * c^2 + s^2)^2
    elseif mode == :aff
        return ((1 + c^2)*ℓ + s^2) / (1 + c^2 + ℓ * s^2)
    end
    throw(ArgumentError("Mode $(mode) is not supported"))
end

const Shrinkage = Union{Symbol, Real}
abstract type LinearShrinkageTarget end

# Taxonomy from https://strimmerlab.github.io/publications/journals/shrinkcov2005.pdf
# page 13

"""
    DiagonalUnitVariance

Target for linear shrinkage: unit matrix.
A subtype of `LinearShrinkageTarget` where

* ``F_{ij}=1`` if ``i=j`` and
* ``F_{ij}=0`` otherwise
"""
struct DiagonalUnitVariance <: LinearShrinkageTarget end

"""
    DiagonalCommonVariance

Target for linear shrinkage: unit matrix multiplied by average variance of
variables.
A subtype of `LinearShrinkageTarget` where

* ``F_{ij}=v`` if ``i=j`` with ``v=\\mathrm{tr}(S)/p`` and
* ``F_{ij}=0`` otherwise
"""
struct DiagonalCommonVariance <: LinearShrinkageTarget end

"""
    DiagonalUnequalVariance

Target for linear shrinkage: diagonal of covariance matrix.
A subtype of `LinearShrinkageTarget` where

* ``F_{ij}=s_{ij}`` if ``i=j`` and
* ``F_{ij}=0`` otherwise
"""
struct DiagonalUnequalVariance <: LinearShrinkageTarget end

"""
    CommonCovariance

Target for linear shrinkage: see `target_C`.
A subtype of `LinearShrinkageTarget` where

* ``F_{ij}=v`` if ``i=j`` with ``v=\\mathrm{tr}(S)/p`` and
* ``F_{ij}=c`` with ``c=\\sum_{i\\neq j} S_{ij}/(p(p-1))`` otherwise
"""
struct CommonCovariance <: LinearShrinkageTarget end

"""
    PerfectPositiveCorrelation

Target for linear shrinkage: see `target_E`.
A subtype of `LinearShrinkageTarget` where

* ``F_{ij}=S_{ij}`` if ``i=j`` and
* ``F_{ij}=\\sqrt{S_{ii}S_{jj}}`` otherwise
"""
struct PerfectPositiveCorrelation <: LinearShrinkageTarget end

"""
    ConstantCorrelation

Target for linear shrinkage: see `target_F`.
A subtype of `LinearShrinkageTarget` where

* ``F_{ij}=S_{ij}`` if ``i=j`` and
* ``F_{ij}=\\overline{r}\\sqrt{S_{ii}S_{jj}}`` otherwise where
  ``\\overline{r}`` is the average sample correlation
"""
struct ConstantCorrelation <: LinearShrinkageTarget end

"""
    LinearShrinkage(target, shrinkage; corrected=false, drop_var0=false)

Linear shrinkage estimator described by equation
``(1 - \\lambda) S + \\lambda F`` where ``S`` is standard covariance matrix,
``F`` is shrinkage target described by argument `target` and ``\\lambda`` is a
shrinkage parameter, either given explicitly in `shrinkage` or automatically
determined according to one of the supported methods.

The corrected estimator is used if `corrected` is true.
`drop_var0=true` drops the zero-variance variables from the computation of `\\lambda`.
"""
struct LinearShrinkage{T<:LinearShrinkageTarget, S<:Shrinkage} <: CovarianceEstimator
    target::T
    shrinkage::S
    corrected::Bool
    drop_var0::Bool

    function LinearShrinkage(t::TT, s::SS; corrected=false, drop_var0=false) where {TT<:LinearShrinkageTarget, SS<:Real}
        0 ≤ s ≤ 1 || throw(ArgumentError("Shrinkage value should be between 0 and 1. Got $s."))
        new{TT, SS}(t, s, corrected, drop_var0)
    end
    function LinearShrinkage(t::TT, s::Symbol=:auto; corrected=false, drop_var0=false) where TT <: LinearShrinkageTarget
        s ∈ (:auto, :lw, :ss, :rblw, :oas) || throw(ArgumentError("Shrinkage method $s not supported."))
        new{TT, Symbol}(t, s, corrected, drop_var0)
    end
end

LinearShrinkage(;
    target::LinearShrinkageTarget=DiagonalUnitVariance(),
    shrinkage::Shrinkage,
    corrected::Bool=false,
    drop_var0::Bool=false) = LinearShrinkage(target, shrinkage, corrected=corrected, drop_var0=drop_var0)

"""
    cov(lse::LinearShrinkage, X, [weights::FrequencyWeights]; dims=1, mean=nothing)

Linear shrinkage covariance estimator for matrix `X` along dimension `dims`.
Computed using the method described by `lse`.

Optionally provide `weights` associated with each observation in `X` (see `StatsBase.FrequencyWeights`).

!!! note
    Theoretical guidance for the use of weights in shrinkage estimation seems sparse.
    `FrequencyWeights` have a straightforward implementation, but support for other `AbstractWeight` subtypes
    awaits analytical justification.
"""
function cov(lse::LinearShrinkage, X::AbstractMatrix{<:Real}, weights::FrequencyWeights...;
             dims::Int=1, mean=nothing)

    dims ∈ (1, 2) || throw(ArgumentError("Argument dims can only be 1 or 2 (given: $dims)"))

    Xc   = (dims == 1) ? copy(X) : copy(transpose(X))
    n, p = size(Xc)
    # sample covariance of size (p x p)
    S = cov(SimpleCovariance(corrected=lse.corrected), X, weights...; dims=dims, mean=mean)
    pvar = p - (lse.drop_var0 ? sum(iszero, diag(S)) : 0)

    # NOTE: don't need to check if mean is proper as this is already done above
    if mean === nothing
        Xc .-= Statistics.mean(Xc, weights...; dims=1)
    elseif mean isa AbstractArray
        if dims == 1
            Xc .-= mean
        else
            Xc .-= mean'
        end
    end

    return linear_shrinkage(lse.target, Xc, S, lse.shrinkage, n, p, pvar, lse.corrected, weights...)
end

##############################################################################
# Helper functions for Linear Shrinkage estimators

"""
    rescale(M, d)

Internal function to scale the rows and the columns of a square matrix `M`
according to the elements in `d`.
This is useful when dealing with the standardised data matrix which can be
written `Xs=Xc*D` where `Xc` is the centered data matrix and `D=Diagonal(d)`
so that its simple covariance is `D*S*D` where `S` is the simple covariance
of `Xc`. Such `D*M*D` terms appear often in the computations of optimal
shrinkage λ.

* Space complexity: ``O(p^2)``
* Time complexity: ``O(p^2)``
"""
rescale(M::AbstractMatrix, d::AbstractVector) = M .* d .* d'


"""
    rescale!(M, d)

Same as `rescale` but in place (no allocation).
"""
rescale!(M::AbstractMatrix, d::AbstractVector) = (M .*= d .* d')


"""
    uccov(X)

Internal function to compute `X*X'/n` where `n` is the number of rows of `X`.
This corresponds to the uncorrected covariance of `X` if `X` is centered.
This operation appears often in the computations of optimal shrinkage λ.

* Space complexity: ``O(p^2)``
* Time complexity: ``O(2np^2)``
"""
uccov(X::AbstractMatrix) = (X' * X) / size(X, 1)
uccov(X::AbstractMatrix, weights::FrequencyWeights) = (X' * (weights .* X)) / sum(weights)


"""
    sumij(S)

Internal function to compute the sum of elements of a square matrix `S`.
A keyword `with_diag` can be passed to indicate whether to include or not the
diagonal of `S` in the sum. Both cases happen often in the computations of
optimal shrinkage λ.

* Space complexity: ``O(1)``
* Time complexity: ``O(p^2)``
"""
function sumij(S::AbstractMatrix; with_diag=false)
    acc = sum(S)
    with_diag || return acc - tr(S)
    return acc
end


"""
    sumij2(S)

Internal function identical to `sumij` except that it passes the function
`abs2` to the sum so that it is the sum of the elements of `S` squared
which is computed. This is significantly more efficient than using
`sumij(S.^2)` for large matrices as it allocates very little.

* Space complexity: ``O(1)``
* Time complexity: ``O(2p^2)``
"""
function sumij2(S::AbstractMatrix; with_diag=false)
    acc = sum(abs2, S)
    with_diag || return acc - sum(abs2, diag(S))
    return acc
end


"""
    sum_fij(Xc, S, n, κ)

Internal function corresponding to ``∑_{i≂̸j}f_{ij}`` that appears in
https://strimmerlab.github.io/publications/journals/shrinkcov2005.pdf p.11.

* Space complexity: ``O(np + 2p^2)``
* Time complexity: ``O(2np^2)``
"""
function sum_fij(Xc, S, n, κ)
    sd  = sqrt.(diag(S))
    sdinv = map(z -> guardeddiv(1, z), sd)
    M   = ((Xc.^3)' * Xc) .* sdinv
    M .-= κ .* S .* sd
    M .*= sd'
    return sumij(M) / (n * κ)
end
function sum_fij(Xc, S, n, κ, weights)
    sd  = sqrt.(diag(S))
    sdinv = map(z -> guardeddiv(1, z), sd)
    M   = ((Xc.^3)' * (weights .* Xc)) .* sdinv
    M .-= κ .* S .* sd
    M .*= sd'
    return sumij(M) / (sum(weights) * κ)
end
##############################################################################

"""
    linear_shrinkage(target, Xc, S, λ, n, p, pvar, corrected, [weights])

Performs linear shrinkage with target of type `target` for data matrix `Xc`
of size `n` by `p` with covariance matrix `S` and shrinkage parameter `λ`.
Calculates corrected covariance if `corrected` is true.

`pvar == p` or `pvar = p - sum(iszero, diag(S))`, the number of non-zero
diagonal variances in `S`. The choice is controlled by `LinearShrinkage(...; drop_var0=true/false)`.
"""
linear_shrinkage

## TARGET A

function linear_shrinkage(::DiagonalUnitVariance, Xc::AbstractMatrix,
                          S::AbstractMatrix, λ::Real, n::Int, p::Int, pvar::Int,
                          corrected::Bool, weights::FrequencyWeights...)

    return linshrink(I, S, λ)
end

"""
    linear_shrinkage(::DiagonalUnitVariance, Xc, S, λ, n, p, pvar, corrected)

Compute the shrinkage estimator where the target is a `DiagonalUnitVariance`.
"""
function linear_shrinkage(::DiagonalUnitVariance, Xc::AbstractMatrix,
                          S::AbstractMatrix, λ::Symbol, n::Int, p::Int, pvar::Int,
                          corrected::Bool, weights::FrequencyWeights...)

    F   = I
    T   = float(eltype(S))
    wn = totalweight(n, weights...)
    κ   = wn - Int(corrected)
    γ   = T(κ/wn)
    Xc² = Xc.^2
    # computing the shrinkage
    if λ ∈ [:auto, :lw]
        ΣS² = sumij2(S, with_diag=true)
        λ   = sumij(uccov(Xc², weights...), with_diag=true) / γ^2 - ΣS²
        λ  /= κ * (ΣS² - 2tr(S) + pvar)
    elseif λ == :ss
        # use the standardised data matrix
        d   = diaginv(pvar < p, oneunit(T), vec(sum(Xc², weights...; dims=1)))
        S̄   = rescale(S, sqrt.(d)) # this has diagonal 1/κ
        ΣS̄² = sumij2(S̄, with_diag=true)
        λ   = sumij(rescale!(uccov(Xc², weights...), d), with_diag=true) / γ^2 - ΣS̄²
        λ  /= T(κ * ΣS̄² - pvar / κ)
    else
        throw(ArgumentError("Unsupported shrinkage method for target DiagonalUnitVariance: $λ."))
    end
    λ = clamp(λ, zero(T), one(T))
    return linshrink(F, S, λ)
end

## TARGET B

target_B(S::AbstractMatrix, pvar::Int) = tr(S)/pvar * I

function linear_shrinkage(::DiagonalCommonVariance, Xc::AbstractMatrix,
                          S::AbstractMatrix, λ::Real, n::Int, p::Int, pvar::Int,
                          corrected::Bool, weights::FrequencyWeights...)

    return linshrink(target_B(S, pvar), S, λ)
end

"""
    linear_shrinkage(::DiagonalCommonVariance, Xc, S, λ, n, p, pvar, corrected)

Compute the shrinkage estimator where the target is a `DiagonalCommonVariance`.
"""
function linear_shrinkage(::DiagonalCommonVariance, Xc::AbstractMatrix,
                          S::AbstractMatrix, λ::Symbol, n::Int, p::Int, pvar::Int,
                          corrected::Bool, weights::FrequencyWeights...)

    F   = target_B(S, pvar)
    T   = float(eltype(F))
    wn = totalweight(n, weights...)
    κ   = wn - Int(corrected)
    γ   = T(κ/wn)
    Xc² = Xc.^2
    # computing the shrinkage
    if λ ∈ [:auto, :lw]
        v   = F.λ # tr(S)/p
        ΣS² = sumij2(S, with_diag=true)
        λ   = sumij(uccov(Xc², weights...), with_diag=true) / γ^2 - ΣS²
        λ  /= κ * (ΣS² - pvar*v^2)
    elseif λ == :ss
        # use the standardised data matrix
        d   = diaginv(pvar < p, oneunit(T), vec(sum(Xc², weights...; dims=1)))
        S̄   = rescale(S, sqrt.(d)) # this has diagonal 1/κ
        v̄   = κ # tr(S̄)/p
        ΣS̄² = sumij2(S̄, with_diag=true)
        λ   = sumij(rescale!(uccov(Xc², weights...), d), with_diag=true) / γ^2 - ΣS̄²
        λ  /= T(κ * ΣS̄² - pvar/κ)
    elseif λ == :rblw
        # https://arxiv.org/pdf/0907.4698.pdf equations 17, 19
        trS² = sum(abs2, S)
        tr²S = tr(S)^2
        # note: using corrected or uncorrected S does not change λ
        λ = T(((wn-2)/wn * trS² + tr²S) / ((wn+2) * (trS² - tr²S/pvar)))
    elseif λ == :oas
        # https://arxiv.org/pdf/0907.4698.pdf equation 23
        trS² = sum(abs2, S)
        tr²S = tr(S)^2
        # note: using corrected or uncorrected S does not change λ
        λ = ((one(T)-T(2.0)/pvar) * trS² + tr²S) / ((wn+one(T)-T(2.0)/pvar) * (trS² - tr²S/pvar))
    else
        throw(ArgumentError("Unsupported shrinkage method for target DiagonalCommonVariance: $λ."))
    end
    λ = clamp(λ, zero(T), one(T))
    return linshrink(F, S, λ)
end

## TARGET D

target_D(S::AbstractMatrix) = Diagonal(S)

function linear_shrinkage(::DiagonalUnequalVariance, Xc::AbstractMatrix,
                          S::AbstractMatrix, λ::Real, n::Int, p::Int, pvar::Int,
                          corrected::Bool, weights::FrequencyWeights...)

    return linshrink(target_D(S), S, λ)
end

"""
    linear_shrinkage(::DiagonalUnequalVariance, Xc, S, λ, n, p, pvar, corrected)

Compute the shrinkage estimator where the target is a `DiagonalUnequalVariance`.
"""
function linear_shrinkage(::DiagonalUnequalVariance, Xc::AbstractMatrix,
                          S::AbstractMatrix, λ::Symbol, n::Int, p::Int, pvar::Int,
                          corrected::Bool, weights::FrequencyWeights...)

    F   = target_D(S)
    T   = float(eltype(F))
    wn = totalweight(n, weights...)
    κ   = wn - Int(corrected)
    γ   = T(κ / wn)
    Xc² = Xc.^2
    # computing the shrinkage
    if λ ∈ [:auto, :lw]
        ΣS² = sumij2(S)
        λ   = sumij(uccov(Xc², weights...)) / γ^2 - ΣS²
        λ  /= κ * ΣS²
    elseif λ == :ss
        keep = diag(S) .> zero(T)
        Xc² = Xc²[:, keep]
        # use the standardised data matrix
        d   = diaginv(pvar < p, oneunit(T), vec(sum(Xc², weights...; dims=1)))
        ΣS̄² = sumij2(rescale(S[keep, keep], sqrt.(d)))
        λ   = sumij(rescale!(uccov(Xc², weights...), d)) / γ^2 - ΣS̄²
        λ  /= κ * ΣS̄²
    else
        throw(ArgumentError("Unsupported shrinkage method for target DiagonalUnequalVariance: $λ."))
    end
    λ = clamp(λ, zero(T), one(T))
    return linshrink(F, S, λ)
end

## TARGET C

function target_C(S::AbstractMatrix, p::Int, pvar::Int)
    v  = tr(S)/pvar
    c  = sumij(S; with_diag=false) / (pvar * (pvar - 1))
    F  = fill(c, (p, p))
    F -= Diagonal(F)
    F += v * I
    return F, v, c
end

function linear_shrinkage(::CommonCovariance, Xc::AbstractMatrix,
                          S::AbstractMatrix, λ::Real, n::Int, p::Int, pvar::Int,
                          corrected::Bool, weights::FrequencyWeights...)

    F, _, _ = target_C(S, p, pvar)
    return linshrink!(F, S, λ)
end

"""
    linear_shrinkage(::CommonCovariance, Xc, S, λ, n, p, pvar, corrected)

Compute the shrinkage estimator where the target is a `CommonCovariance`.
"""
function linear_shrinkage(::CommonCovariance, Xc::AbstractMatrix,
                          S::AbstractMatrix, λ::Symbol, n::Int, p::Int, pvar::Int,
                          corrected::Bool, weights::FrequencyWeights...)

    F, v, c = target_C(S, p, pvar)
    T   = float(eltype(F))
    wn = totalweight(n, weights...)
    κ   = wn - Int(corrected)
    γ   = T(κ/wn)
    Xc² = Xc.^2
    # computing the shrinkage
    if λ ∈ [:auto, :lw]
        ΣS² = sumij2(S, with_diag=true)
        λ   = sumij(uccov(Xc², weights...), with_diag=true) / γ^2 - ΣS²
        λ  /= κ * (ΣS² - pvar*(pvar-1)*c^2 - pvar*v^2)
    elseif λ == :ss
        d   = diaginv(pvar < p, oneunit(T), vec(sum(Xc², weights...; dims=1)))
        S̄   = rescale(S, sqrt.(d))
        ΣS̄² = sumij2(S̄, with_diag=true)
        λ   = sumij(rescale!(uccov(Xc², weights...), d), with_diag=true) / γ^2 - ΣS̄²
        λ  /= κ * ΣS̄² - pvar/κ - κ * sumij(S̄; with_diag=false)^2 / (pvar * (pvar - 1))
    else
        throw(ArgumentError("Unsupported shrinkage method for target CommonCovariance: $λ."))
    end
    λ = clamp(λ, zero(T), one(T))
    return linshrink!(F, S, λ)
end

## TARGET E

function target_E(S::AbstractMatrix)
    d = sqrt.(diag(S))
    return d*d'
end

function linear_shrinkage(::PerfectPositiveCorrelation, Xc::AbstractMatrix,
                          S::AbstractMatrix, λ::Real, n::Int, p::Int, pvar::Int,
                          corrected::Bool, weights::FrequencyWeights...)

    return linshrink!(target_E(S), S, λ)
end

"""
    linear_shrinkage(::PerfectPositiveCorrelation, Xc, S, λ, n, p, pvar, corrected)

Compute the shrinkage estimator where the target is a
`PerfectPositiveCorrelation`.
"""
function linear_shrinkage(::PerfectPositiveCorrelation, Xc::AbstractMatrix,
                          S::AbstractMatrix, λ::Symbol, n::Int, p::Int, pvar::Int,
                          corrected::Bool, weights::FrequencyWeights...)

    F   = target_E(S)
    T   = float(eltype(F))
    wn = totalweight(n, weights...)
    κ   = wn - Int(corrected)
    γ   = T(κ/wn)
    Xc² = Xc.^2
    # computing the shrinkage
    if λ ∈ [:auto, :lw]
        ΣS² = sumij2(S)
        λ   = (sumij(uccov(Xc², weights...)) / γ^2 - ΣS²) / κ
        λ  -= sum_fij(Xc, S, n, κ, weights...)
        λ  /= sumij2(S - F)
    elseif λ == :ss
        d   = diaginv(pvar < p, oneunit(T), vec(sum(Xc², weights...; dims=1)))
        s   = sqrt.(d)
        S̄   = rescale(S, s)
        ΣS̄² = sumij2(S̄)
        λ   = (sumij(rescale!(uccov(Xc², weights...), d)) / γ^2 - ΣS̄²) / κ
        λ  -= sum_fij(Xc .* s', S̄, n, κ, weights...)
        F̄  = target_E(S̄)
        λ  /= sumij2(S̄ - F̄)
    else
        throw(ArgumentError("Unsupported shrinkage method for target PerfectPositiveCorrelation: $λ."))
    end
    λ = clamp(λ, zero(T), one(T))
    return linshrink!(F, S, λ)
end

## TARGET F

function target_F(S::AbstractMatrix, p::Int, pvar::Int)
    s  = sqrt.(diag(S))
    sinv = pvar < p ? map(z -> guardeddiv(1, z), s) : 1 ./ s
    sinv_ = sinv*sinv'
    r̄  = (sum(S .* sinv_) - pvar) / (pvar * (pvar - 1))
    F_ = r̄ * (s*s')
    F  = F_ + (Diagonal(S) - Diagonal(F_))
    return F, r̄
end

function linear_shrinkage(::ConstantCorrelation, Xc::AbstractMatrix,
                          S::AbstractMatrix, λ::Real, n::Int, p::Int, pvar::Int,
                          corrected::Bool, weights::FrequencyWeights...)

    F, _ = target_F(S, p, pvar)
    return linshrink!(F, S, λ)
end

"""
    linear_shrinkage(::ConstantCorrelation, Xc, S, λ, n, p, pvar, corrected)

Compute the shrinkage estimator where the target is a `ConstantCorrelation`.
"""
function linear_shrinkage(::ConstantCorrelation, Xc::AbstractMatrix,
                          S::AbstractMatrix, λ::Symbol, n::Int, p::Int, pvar::Int,
                          corrected::Bool, weights::FrequencyWeights...)

    F, r̄ = target_F(S, p, pvar)
    T    = float(eltype(F))
    wn = totalweight(n, weights...)
    κ    = wn - Int(corrected)
    γ    = T(κ/wn)
    Xc²  = Xc.^2
    # computing the shrinkage
    if λ ∈ [:auto, :lw]
        ΣS² = sumij2(S)
        λ   = (sumij(uccov(Xc², weights...)) / γ^2 - ΣS²) / κ
        λ  -= r̄ * sum_fij(Xc, S, n, κ, weights...)
        λ  /= sumij2(S - F)
    elseif λ == :ss
        d   = diaginv(pvar < p, oneunit(T), vec(sum(Xc², weights...; dims=1)))
        s    = sqrt.(d)
        S̄    = rescale(S, s)
        F̄, r̄ = target_F(S̄, p, pvar)
        ΣS̄²  = sumij2(S̄)
        λ    = (sumij(rescale!(uccov(Xc², weights...), d)) / γ^2 - ΣS̄²) / κ
        λ   -= r̄ * sum_fij(Xc .* s', S̄, n, κ, weights...)
        λ   /= sumij2(S̄ - F̄)
    else
        throw(ArgumentError("Unsupported shrinkage method for target ConstantCorrelation: $λ."))
    end
    λ = clamp(λ, zero(T), one(T))
    return linshrink!(F, S, λ)
end

@testset "Float32 matrices" begin
    # linear shrinkages
    for X in test_matrices
        x = convert(Matrix{Float32}, X)
        for target in [
            DiagonalUnitVariance(),
            DiagonalCommonVariance(),
            DiagonalUnequalVariance(),
            CommonCovariance(),
            PerfectPositiveCorrelation(),
            ConstantCorrelation()
            ]
            for shrinkage in [:lw, :ss]
                @test eltype(cov(LinearShrinkage(target, shrinkage), x)) == Float32
            end
        end
    end

    # nonlinear shrinkages
    ANS = AnalyticalNonlinearShrinkage()
    for X in test_matrices
        size(X, 1) < 12 && continue
        x = convert(Matrix{Float32}, X)
        @test eltype(cov(ANS, x)) == Float32
    end
end

using CovarianceEstimation
using Test
using Statistics
using StatsBase
using WoodburyMatrices

function wapprox(W1::SymWoodbury, W2::SymWoodbury; atolU=1e-6, kwargs...)
    isapprox(W1.A, W2.A; kwargs...) && isapprox(W1.D, W2.D; kwargs...) || return false
    # For B, each column can have sign flipped without changing the matrix
    for (col1, col2) in zip(eachcol(W1.B), eachcol(W2.B))
        isapprox(col1, col2; atol=atolU, kwargs...) || isapprox(col1, -col2; atol=atolU, kwargs...) || return false
    end
    return true
end

function woodbury_test(ce::WoodburyEstimator, X̂)
    c = cov(ce, X̂)
    @test issymmetric(c)
    @test wapprox(cov(ce, X̂'; dims=2), c)
    n2 = size(X̂, 1) ÷ 2
    w = FrequencyWeights(vcat(ones(n2), zeros(size(X̂, 1) - n2)))
    chalf = cov(ce, X̂, w);
    @test wapprox(chalf, cov(ce, X̂[1:n2, :]))
    # Weight types besides FrequencyWeights are not supported
    aw1 = AnalyticWeights(rand(size(test_matrices[1], 1)))
    @test_throws Exception cov(ce, test_matrices[1], aw1)
    @test_throws Exception cov(ce, test_matrices[1], aw1; dims=2)
    @test_throws Exception cov(ce, test_matrices[1], aw1; mean=nothing)
end

@testset "Woodbury shrinkage" begin
    @test_throws ArgumentError NormLossCov(:not_a_norm, 1)
    @test_throws ArgumentError NormLossCov(:L2, 0)
    for norm in (:L1, :L2, :Linf)
        for pivotidx in 1:7
            if pivotidx ∈ (5, 7) || (norm == :Linf && pivotidx ∈ (3, 4))
                X̂ = test_matrices[argmax([size(X̂, 1) for X̂ ∈ test_matrices])]
                @test_throws ArgumentError cov(WoodburyEstimator(NormLossCov(norm, pivotidx), 2), X̂)
                continue
            end
            loss = NormLossCov(norm, pivotidx)
            for X̂ ∈ test_matrices
                size(X̂, 1) < 6 && continue
                woodbury_test(WoodburyEstimator(loss, 2), X̂)
            end
        end
    end
    @test_throws ArgumentError StatLossCov(:oops)
    for mode in (:st, :ent, :div, :aff, :fre)
        loss = StatLossCov(mode)
        for X̂ ∈ test_matrices
            size(X̂, 1) < 6 && continue
            woodbury_test(WoodburyEstimator(loss, 2), X̂)
        end
    end
    # Take a case where we have some idea of what to expect: make a low-rank modification to a noise matrix
    Y = Xe
    v = zeros(size(Y, 2))
    v[1] = 100
    Y = [Y; v'; -v']    # avoid perturbing the mean
    ce = WoodburyEstimator(StatLossCov(:ent), 2; σ²=1)
    C = cov(ce, Y)
    @test Matrix(C) ≈ cov(Y) rtol=0.1
    @test C.D[1,1] ≈ 400 rtol=0.1
    @test size(C.D) == (1, 1) || abs(C.D[2,2]) < 1
    @test all(==(1), diag(C.A))
    @test abs(C.B[1,1]) > 0.99
    @test wapprox(cov(ce, similar(Y); UsV = CovarianceEstimation.tsvd(Y .- mean(Y; dims=1), 2)), C)
end

"""
    BiweightMidcovariance(; c=9.0, modify_sample_size=false)

The biweight midcovariance is a covariance estimator that is resilient to outliers.

The technique derives originally from astrophysics [1], and is implemented in the Python
module [Astropy](https://www.astropy.org/) [2], as well as in NIST's Dataplot [3].

Consider two random variables ``x`` and ``y``, for which we have ``n`` observations
``\\{(x_i, y_i)\\}``. The biweight midcovariance is then defined to be:
```math
n_s\\cdot\\frac{
    \\sum_{|u_i|<1,|v_i|<1}(x_i - M_x)(1 - u_i^2)^2(y_i - M_y)(1 - v_i^2)^2
}{
    \\left(\\sum_{|u_i|<1}(1 - u_i^2)(1-5u_i^2)\\right)
    \\left(\\sum_{|v_i|<1}(1 - v_i^2)(1-5v_i^2)\\right)
}
```
where ``n_s`` is the sample size, ``M_x`` and ``M_y`` are the medians of ``\\{x_i\\}`` and
``\\{y_i\\}`` respectively, and
```math
\\begin{aligned}
u_i &= \\frac{x_i - M_x}{c \\cdot \\mathrm{MAD}_x} \\\\
v_i &= \\frac{y_i - M_y}{c \\cdot \\mathrm{MAD}_y},
\\end{aligned}
```
where ``\\mathrm{MAD}`` represents the median absolute deviation,
```math
\\begin{aligned}
\\mathrm{MAD}_x &= \\mathrm{median}(\\left\\{\\left|x_i - M_x\\right|\\right\\}) \\\\
\\mathrm{MAD}_y &= \\mathrm{median}(\\left\\{\\left|y_i - M_y\\right|\\right\\}).
\\end{aligned}
```

If either ``\\mathrm{MAD}_x = 0`` or ``\\mathrm{MAD}_y = 0``, the pairwise covariance is
defined to be zero.

The parameter ``c`` is a tuning constant, for which the default is ``9.0``.
Larger values will reduce the number of outliers that are removed — i.e. reducing
robustness, but increasing sample efficiency.

# Fields
- `c::Float64`: The tuning constant corresponding to ``c`` above.
- `modify_sample_size::Bool`: If `false`, then we use a sample size ``n_s`` equal to the
    total number of observations ``n``. This is consistent with the standard definition of
    biweight midcovariance in the literature. Otherwise, we count only those elements which
    are not rejected as outliers in the numerator, i.e. those for which ``|u_i|<1``
    and ``|v_i|<1``.
    This follows the implementation in astropy [2].

# Complexity
- Space: ``O(p^2)``
- Time: ``O(np^2)``

# References
[1] Beers, Flynn, and Gebhardt (1990; AJ 100, 32)
"Measures of Location and Scale for Velocities in Clusters of Galaxies -- A Robust Approach"

[2] [Astropy biweight_midcovariance](https://docs.astropy.org/en/stable/api/astropy.stats.biweight_midcovariance.html)

[3] [NIST Dataplot biweight midcovariance](https://www.itl.nist.gov/div898/software/dataplot/refman2/auxillar/biwmidc.htm)
"""
struct BiweightMidcovariance <: CovarianceEstimator
    c::Float64
    modify_sample_size::Bool
end
function BiweightMidcovariance(; c::Real=9.0, modify_sample_size::Bool=false)
    c > 0 || throw(ArgumentError("c must be positive, got $c"))
    return BiweightMidcovariance(Float64(c), modify_sample_size)
end

function covzm(ce::BiweightMidcovariance, x::AbstractVector{<:Real})
    MADx = median!(abs.(x))
    numerator = zero(eltype(x))

    # If MADx is zero, return zero.
    iszero(MADx) && return zero(one(eltype(x)) / 1)

    denominator = zero(eltype(x))
    count = 0
    for xi in x
        ui² = (xi / (ce.c * MADx))^2
        # Benchmarking suggests that having this branch is similar or faster to a form
        # using `ifelse`, where we always compute the updates but avoid the branch.
        ui² >= 1 && continue
        count += 1
        numerator += xi^2 * (1 - ui²)^4
        denominator += (1 - ui²) * (1 - 5 * ui²)
    end
    n = ifelse(ce.modify_sample_size, count, length(x))
    return n * numerator / (denominator^2)
end

function cov(
    ce::BiweightMidcovariance,
    x::AbstractVector{<:Real};
    mean::Union{Nothing,<:Real}=nothing,
)
    Mx = mean === nothing ? median(x) : mean
    return covzm(ce, x .- Mx)
end

function covzm(
    ce::BiweightMidcovariance, x::AbstractVector{<:Real}, y::AbstractVector{<:Real}
)
    MADx = median!(abs.(x))
    MADy = median!(abs.(y))

    # Promote types between x & y for numerator
    numerator = zero(promote_type(eltype(x), eltype(y)))

    # If either of the MADs are zero, return zero.
    #   `numerator` is always zero here, and of the correct type.
    iszero(MADx) && return numerator
    iszero(MADy) && return numerator

    denominator_x = zero(eltype(x))
    denominator_y = zero(eltype(y))
    count = 0
    for (xi, yi) in zip(x, y)
        ui² = (xi / (ce.c * MADx))^2
        vi² = (yi / (ce.c * MADy))^2

        # Compute the updates, and increment if desired.
        # This way should avoid branches, and benchmarks suggest it's 1-2% faster than
        # using conditionals.
        ax = (1 - ui²) * (1 - 5 * ui²)
        ay = (1 - vi²) * (1 - 5 * vi²)
        anum = xi * (1 - ui²)^2 * yi * (1 - vi²)^2

        denominator_x += ifelse(ui² < 1, ax, zero(denominator_x))
        denominator_y += ifelse(vi² < 1, ay, zero(denominator_y))
        i_count, i_numerator = ifelse(ui² < 1 && vi² < 1, (1, anum), (0, zero(numerator)))
        count += i_count
        numerator += i_numerator
    end

    n = ifelse(ce.modify_sample_size, count, length(x))
    return n * numerator / (denominator_x * denominator_y)
end

function cov(
    ce::BiweightMidcovariance, x::AbstractVector{<:Real}, y::AbstractVector{<:Real}
)
    if size(x) != size(y)
        throw(ArgumentError("x & y have different sizes, $(size(x)) & $(size(y))"))
    end

    return covzm(ce, x .- median(x), y .- median(y))
end

function cov(
    ce::BiweightMidcovariance,
    X::AbstractMatrix{<:Real};
    mean::Union{Nothing,AbstractVector{<:Real},AbstractMatrix{<:Real}}=nothing,
    dims::Int=1,
)
    dims ∈ (1, 2) || throw(ArgumentError("Argument dims can only be 1 or 2 (given: $dims)"))

    # Ascertain the number of observations `n` and number of variables `p`.
    n, p = dims == 1 ? size(X) : (size(X, 2), size(X, 1))

    # Temporary storage to use when computing medians.
    temp = Vector{eltype(X)}(undef, n)

    # If the `mean` argument isn't provided, then we centralise with the median.
    # After this statement, Xc is standardised to be of shape (n, p)
    Xc = if mean === nothing
        # The following is equivalent to
        #   X .- median(X; dims=dims)
        # However, this implementation significantly reduces the runtime of this function.
        # This is primarily achieved by reducing the number of allocations -- we allocate a
        # single temporary buffer which we allow `median!` to mutate, and then copy the next
        # section of data into it.
        X = dims == 2 ? transpose(X) : X
        Xc = copy(X)
        @inbounds for i in 1:p
            # Avoiding copyto!(, ... @view(X[:, i])), because this can allocate a view if
            # the call to copyto! isn't inlined.
            for j in 1:n
                temp[j] = X[j, i]
            end
            Xc[:, i] .-= median!(temp)
        end
        Xc
    else
        Xc = X .- mean
        # Standardise the orientation of Xc.
        dims == 2 ? transpose(Xc) : Xc
    end

    # Compute all the median absolute deviations.
    # To avoid extra allocations, use a temporary buffer `temp` which will be populated with
    # the absolute values of the observations of each variable, and which we then allow
    # median! to mutate.
    T = typeof(one(eltype(X)) / 1)  # This is the output type of median.
    MAD = Matrix{T}(undef, 1, p)
    @inbounds for i in 1:p
        # Avoiding map!(abs, temp, @view(Xc[:, i])), because this can allocate a view if
        # the call to map! isn't inlined.
        for j in 1:n
            temp[j] = abs(Xc[j, i])
        end
        MAD[1, i] = median!(temp)
    end

    u² = @. (Xc / (ce.c * MAD))^2

    onesubu² = max.((1 .- u²), 0)
    a = @. Xc * onesubu²^2
    numerator = a' * a

    a[:, :] .= @. onesubu² * (1 - 5 * u²)  # Re-use `a` memory to avoid an allocation.
    b = sum(a; dims=1)
    denominator = b' * b

    n = if ce.modify_sample_size
        mask = onesubu² .> 0
        mask' * mask
    else
        n
    end

    # Re-use the numerator memory for the result.
    result = numerator
    result .*= n ./ denominator

    # Whereever the MAD is zero, we should set the result to zero.
    mad_zero = dropdims(iszero.(MAD); dims=1)
    result[mad_zero, :] .= zero(eltype(result))
    result[:, mad_zero] .= zero(eltype(result))

    return result
end

# NOTE: these are older implementations/functions which were used in the past
# but have now been optimised heavily and ultimately replaced by other
# functions they're only kept here for the tests.

function sum_var_sij(Z::AbstractMatrix, CovZ::AbstractMatrix, n::Int,
                     corrected=false; with_diag=true)
    scale = ifelse(corrected, n-1, n)
    Z²    = Z.^2
    π̂mat  = ((Z²'*Z²)/n - CovZ.^2) / scale
    with_diag && return sum(π̂mat)
    return sum(π̂mat) - sum(diag(π̂mat))
end

function centercols(X::AbstractMatrix, μ=nothing; dims=1)
    Xc = (dims == 1) ? copy(X) : transpose(X)
    if μ === nothing
        Xc .-= mean(X, dims=1)
    elseif iszero(μ)
        # assume X is centered already
    elseif μ isa AbstractVector
        @assert length(μ) == size(Xc, 2) "Dimension mismatch, given mean has length $(length(μ)) while p=$(size(Xc, 2))"
        Xc .-= μ
    else
        throw(ArgumentError("Incorrect assignment for `mean`, expected either 0, nothing or a vector, got $μ."))
    end
    Xc
end

function linshrink(F::AbstractMatrix, S::AbstractMatrix, λ::Real)
    return Symmetric((one(λ) .- λ).*S .+ λ.*F)
end

function linshrink(F::UniformScaling, S::AbstractMatrix, λ::Real)
    return Symmetric((one(λ) .- λ).*S + λ.*F)
end

function linshrink!(F::AbstractMatrix, S::AbstractMatrix, λ::Real)
    F .= (one(λ) .- λ).*S .+ λ.*F
    return Symmetric(F)
end

totalweight(n) = n
totalweight(_, weights) = sum(weights)

# Dividing by zero produces zero
guardeddiv(num, denom) = iszero(denom) ? zero(num)/oneunit(denom) : num/denom
diaginv(guard::Bool, num, v) = guard ? map(z -> guardeddiv(num, z), v) : num ./ v

function weightedX(X::AbstractMatrix, weights::FrequencyWeights; dims=1)
    rootweights = sqrt.(weights)
    return dims == 1 ? X .* rootweights : rootweights' .* X
end
weightedX(X::AbstractMatrix; dims=1) = X

@testset "Analytical Nonlin shrinkage (ref⭒) " begin
    ANS = AnalyticalNonlinearShrinkage()
    for X̂ ∈ test_matrices
        size(X̂, 1) < 12 && continue
        ref_result = matlab_ledoitwolf_analytical_shrinkage(X̂)
        c = cov(ANS, X̂); @test c ≈ ref_result
        @test issymmetric(c)
        size(X̂, 1) < 24 && continue
        n2 = size(X̂, 1) ÷ 2
        w = FrequencyWeights(vcat(ones(n2), zeros(size(X̂, 1) - n2)))
        ref_result = matlab_ledoitwolf_analytical_shrinkage(X̂[1:n2, :])
        c = cov(ANS, X̂, w); @test c ≈ ref_result
        # Weight types besides FrequencyWeights are not supported
        aw1 = AnalyticWeights(rand(size(test_matrices[1], 1)))
        @test_throws ErrorException cov(ANS, test_matrices[1], aw1)
        @test_throws ErrorException cov(ANS, test_matrices[1], aw1; dims=2)
        @test_throws ErrorException cov(ANS, test_matrices[1], aw1; mean=nothing)
    end
end

"""
    AnalyticalNonlinearShrinkage

Analytical nonlinear shrinkage estimator. See docs for
`analytical_nonlinear_shrinkage` for details.
"""
struct AnalyticalNonlinearShrinkage{TEigen<:Union{Eigen,Nothing}} <: CovarianceEstimator
    decomp::TEigen
    corrected::Bool
    function AnalyticalNonlinearShrinkage(;corrected=false)
        new{Nothing}(nothing, corrected)
    end
    function AnalyticalNonlinearShrinkage(decomp::Eigen; corrected=false)
        new{Eigen}(decomp, corrected)
    end
end


const SQRT5  = sqrt(5.0)
const INVPI  = 1.0 / π
const EPAN_1 = 3.0/(4.0 * SQRT5)
const EPAN_2 = EPAN_1 * INVPI
const EPAN_3 = 0.3 * INVPI

"""
    epanechnikov(x)

Return the Epanechnikov kernel evaluated at `x`.
"""
epanechnikov(x::T) where T<:Real = float(T)(EPAN_1 * max(0.0, 1.0 - x^2/5.0))

"""
    epnanechnikov_HT(x)

Return the Hilbert Transform of the Epanechnikov kernel evaluated at `x`
if `|x|≂̸√5`.
"""
function epanechnikov_HT1(x::T) where T <: Real
    float(T)(-EPAN_3 * x + EPAN_2 * (1.0 - x^2/5.0) * log(abs((SQRT5 - x)/(SQRT5 + x))))
end

"""
    epnanechnikov_HT2(x)
Return the Hilbert Transform of the Epanechnikov kernel evaluated at `x`
if `|x|=√5`.
"""
epanechnikov_HT2(x::T) where T <: Real = float(T)(-EPAN_3*x)

"""
    analytical_nonlinear_shrinkage(S, n, p; decomp)

Internal implementation of the analytical nonlinear shrinkage. The
implementation is inspired from the Matlab code given in section C of
Olivier Ledoit and Michael Wolf's paper "Analytical Nonlinear
Shrinkage of Large-Dimensional Covariance Matrices". (Nov 2018)
http://www.econ.uzh.ch/static/wp/econwp264.pdf
"""
function analytical_nonlinear_shrinkage(S::AbstractMatrix{<:Real},
                                        n::Int, p::Int, est_mean::Bool;
                                        decomp::Union{Nothing,Eigen}=nothing)

    η = ifelse(p < n, n, n - Int(est_mean)) # effective sample size
    # sample eigenvalues sorted in ascending order and eigenvectors
    F    = isa(decomp, Nothing) ? eigen(S) : decomp # O(p^3)
    perm = sortperm(F.values)
    sample_perm = @view perm[max(1, (p - η) + 1):p]
    λ    = @view F.values[sample_perm]
    U    = F.vectors[:, perm]
    T    = float(eltype(F))

    # dominant cost forming of S or eigen(S) --> O(max{np^2, p^3})

    # compute analytical nonlinear shrinkage kernel formula
    L = repeat(λ, outer=(1, min(p, η)))

    # Equation (4.9)
    h = T(η^(-1//3))
    H = h * L'
    x = (L .- L') ./ H

    # additional useful definitions
    γ  = T(p/η)
    πλ = π * λ

    # Equation (4.7) in http://www.econ.uzh.ch/static/wp/econwp264.pdf
    f̃ = vec(mean(epanechnikov.(x) ./ H, dims=2))

    # Equation (4.8)
    Hf̃_tmp = epanechnikov_HT1.(x)
    # if by any chance there are x such that |x| ≈ √5 ...
    mask = (@. abs(x) ≈ SQRT5)
    any(mask) && (Hf̃_tmp[mask] = epanechnikov_HT2.(@view x[mask]))
    Hf̃ = vec(mean(Hf̃_tmp ./ H, dims=2))

    # dominant cost up to here: elementwise ops on x --> O(max{p^2, η^2})

    if p <= η
        # Equation (4.3)
        πγλ = γ * πλ
        denom = @. (πγλ * f̃)^2 + (one(T) - γ - πγλ * Hf̃)^2
        d̃ = λ ./ denom
    else
        # Equation (C.8)
        hs5  = T(h * SQRT5)
        Hf̃0  = T((0.3/h^2 + 0.75/hs5 * (1.0 - 0.2/h^2) * log((1+hs5)/(1-hs5))))
        Hf̃0 *= mean(one(T) ./ πλ)
        # Equation (C.5)
        d̃0 = T(INVPI / ((γ - one(T)) * Hf̃0))
        # Eq. (C.4)
        d̃1 = @. one(T) / (π * πλ * (f̃^2 + Hf̃^2))
        d̃  = [fill(d̃0, (p - η, 1)); d̃1]
    end

    # Equation (4.4)
    return Symmetric(U*(d̃ .* U'))
end

"""
    cov(ans::AnalyticalNonlinearShrinkage, X, [weights]; dims=1, mean=nothing)

Nonlinear covariance estimator derived from the sample covariance estimator `S`
and its eigenvalue decomposition (which can be given through `decomp`).
See Ledoit and Wolf's paper http://www.econ.uzh.ch/static/wp/econwp264.pdf
The keyword `mean` can be `nothing` (centering via estimated mean),
zero (no centering) or a provided vector. In the first case, a rank-1
modification is applied and therefore the effective sample size is decreased
by one (see `analytical_nonlinear_shrinkage`). In the latter two case the mean
cannot have been estimated on the data (otherwise the effective sample size
will be 1 larger than it should be resulting in numerical instabilities).
If you are unsure, use either `nothing` or provide an explicit (non-estimated)
vector (possibly a zero vector) and avoid the use of `mean=0`.

* Time complexity (including formation of `S`)
    - (p<n): O(np^2 + n^2) with moderate constant
    - (p>n): O(p^3) with low constant (dominated by eigendecomposition of S)
"""
function cov(ans::AnalyticalNonlinearShrinkage, X::AbstractMatrix{<:Real}, weights::FrequencyWeights...;
             dims::Int=1, mean=nothing)

    @assert dims ∈ [1, 2] "Argument dims can only be 1 or 2 (given: $dims)"

    szx    = size(X)
    (n, p) = ifelse(dims==1, szx, reverse(szx))
    wn = floor(Int, totalweight(n, weights...))

    # explained in the paper there must be at least 12 samples
    (wn < 12) && throw(ArgumentError("The (weighted) number of samples `n` must be at " *
                                    "least 12 (given: $wn)."))

    S  = cov(SimpleCovariance(corrected=ans.corrected), X, weights...; dims=dims, mean=mean)
    return analytical_nonlinear_shrinkage(S, wn, p, mean === nothing;
                decomp=ans.decomp)
end

# ==========================================================================
# This script compares the facilities offered by CovarianceEstimation.jl
# to existing packages and compares the performances for a set of reasonably
# large matrices.
#
# Libraries considered:
#
# - [python] sklearn
# - [R] corpcor
# - [Matlab/Octave] Ledoit & Wolf's implementations
#
# ==========================================================================

using CovarianceEstimation
using Random: seed!
using DelimitedFiles
using Statistics
using LinearAlgebra

seed!(65489) # random seed for reproducibility

p = [20, 40, 200, 400]
n = [40, 20, 400, 200]
L = [randn(pᵢ, pᵢ) for pᵢ ∈ p]
C = [Lᵢ' * Lᵢ for Lᵢ ∈ L]

X = [randn(n[i], p[i]) * L[i] for i ∈ eachindex(p)]

for Cᵢ ∈ C
    pᵢ = size(Cᵢ, 1)
    writedlm("benchmark/tmpmat/C_$(pᵢ).csv", Cᵢ)
end

for Xᵢ ∈ X
    nᵢ, pᵢ = size(Xᵢ)
    writedlm("benchmark/tmpmat/X_$(nᵢ)x$(pᵢ).csv", Xᵢ)
    # octave is unstable for eigenvalue decomposition so we do everything here
    F = eigen(Xᵢ' * Xᵢ / size(Xᵢ, 1))
    writedlm("benchmark/tmpmat/S_lambda_$(nᵢ)x$(pᵢ).csv", F.values)
    writedlm("benchmark/tmpmat/S_u_$(nᵢ)x$(pᵢ).csv", F.vectors)
end

# =========
# SKLEARN
# =========
oas = LinearShrinkage(
        target=DiagonalCommonVariance(),
        shrinkage=:oas)
lw = LinearShrinkage(
        target=DiagonalCommonVariance(),
        shrinkage=:lw)
times = zeros(length(p))
res = zeros(length(p))
for i ∈ eachindex(p)
    Xᵢ = X[i]
    Cᵢ = C[i]
    start = time()
    C_oas = cov(oas, Xᵢ)
    times[i] = time() - start
    res[i] = norm(C_oas - Cᵢ)
end
res_ours = res
times_ours = times
res_sklearn = [  51.05167435  214.21678806 1602.04944525 6533.94732887][:]
times_sklearn = [0.00026703 0.00023913 0.00225997 0.00262403][:]

δ = mean(res_ours - res_sklearn)
speedup = mean(times_sklearn ./ times_ours)

for i ∈ eachindex(p)
    Xᵢ = X[i]
    Cᵢ = C[i]
    start = time()
    C_lw = cov(lw, Xᵢ)
    times[i] = time() - start
    res[i] = norm(C_lw - Cᵢ)
end
res_ours = res
times_ours = times
res_sklearn = [  50.95012365  215.37414448 1602.01890586 6534.65450682][:]
times_sklearn = [0.00076485 0.00042701 0.00249386 0.00562191][:]

δ = mean(res_ours - res_sklearn)
speedup = mean(times_sklearn ./ times_ours)


# =========
# CORPCOR
# =========
ss = LinearShrinkage(
        target=DiagonalUnequalVariance(),
        shrinkage=:ss)
times = zeros(length(p))
res = zeros(length(p))
for i ∈ eachindex(p)
    Xᵢ = X[i]
    Cᵢ = C[i]
    start = time()
    C_ss = cov(ss, Xᵢ)
    times[i] = time() - start
    res[i] = norm(C_ss - Cᵢ)
end
res_ours = res
times_ours = times
res_corpcor = [  51.39624  219.00562 1606.20378 6562.85887][:]
times_corpcor = [0.001765013, 0.001574039, 0.1169169, 0.122371]

δ = mean(res_ours .- res_corpcor)

# roughly 22x speedup
speedup = mean(times_corpcor ./ times_ours)


# ===============
# LEDOIT WOLF 1
# ===============
lw = LinearShrinkage(
        target=ConstantCorrelation(),
        shrinkage=:lw)
times = zeros(length(p))
res = zeros(length(p))
for i ∈ eachindex(p)
    Xᵢ = X[i]
    Cᵢ = C[i]
    start = time()
    C_lw = cov(lw, Xᵢ)
    times[i] = time() - start
    res[i] = norm(C_lw - Cᵢ)
end
res_ours = res
times_ours = times
res_lw1 = [  51.503, 221.721, 1606.199, 6563.666]
times_lw1 = [0.0017309, 0.0015059, 0.0107820, 0.0208941]

δ = mean(res_ours .- res_lw1)

# roughly 10x speedup
speedup = mean(times_lw1 ./ times_ours)


# ===============
# LEDOIT WOLF 2
# ===============
lw = AnalyticalNonlinearShrinkage()
times = zeros(length(p))
res = zeros(length(p))
for i ∈ [1, 3] # fat matrix don't work reliably atm, see #38
    Xᵢ = X[i]
    Cᵢ = C[i]
    start = time()
    C_lw = cov(lw, Xᵢ)
    times[i] = time() - start
    res[i] = norm(C_lw - Cᵢ)
end
res_ours = res
times_ours = times
res_lw2 = [ 49.10317, 6985.10751]
times_lw2 = [0.015798, 0.007848]

# to our advantage
δ = mean(res_ours[[1, 3]] .- res_lw2)

# roughly 25x speedup
speedup = mean(times_lw2 ./ times_ours[[1, 3]])


# =========
# ASTROPY
# =========
bw = BiweightMidcovariance()
times = zeros(length(p))
res = zeros(length(p))
for i ∈ eachindex(p)
    Xᵢ = X[i]
    Cᵢ = C[i]
    start = time()
    C_bw = cov(bw, Xᵢ)
    times[i] = time() - start
    res[i] = norm(C_bw - Cᵢ)
end
res_ours = res
times_ours = times
res_astropy = [   70.41980995   331.84897257  1975.77842564 11556.0246496][:]
times_astropy = [0.00025606 0.00023079 0.00453758 0.00508738][:]

δ = mean(res_ours .- res_astropy)

# speedup varies from x5 for small matrices to ~similar speed for large matrices.
# The average speedup is ~x3 by this definition.
speedups = times_astropy ./ times_ours
speedup = mean(speedups)

using Documenter, CovarianceEstimation, StatsBase

makedocs(
    modules = [CovarianceEstimation],
    format = Documenter.HTML(; prettyurls=get(ENV, "CI", "false") == "true"),
    sitename = "CovarianceEstimation.jl",
    authors = "Mateusz Baran, Thibaut Lienart, and contributors.",
    pages = [
        "Home" => "index.md",
        "Manual" => Any[
            "Methods" => "man/methods.md",
            "Linear shrinkage estimators" => "man/lshrink.md",
            "Nonlinear shrinkage estimators" => "man/nlshrink.md",
            "MSE comparisons" => "man/msecomp.md"
        ],
        "Library" => Any[
            "Public" => "lib/public.md",
            "Internals" => "lib/internals.md"
        ],
    ],
)

deploydocs(
    repo = "github.com/mateuszbaran/CovarianceEstimation.jl.git", push_preview = true
)

# Covariance estimation for high-dimensional data
# Uses a covariance model of the form `Σ = σ²I + U * Λ * U'`, where `U` is a low-rank matrix of eigenvectors and
# `Λ` is a diagonal matrix capturing the excess width along the dimensions in `U` compared to isotropic.

# If you're curious about dispatch and inferrability, see the "Implementation note" at the top of src/loss.jl.
# We employ the same de-specialization trick even for `σ²` in `WoodburyEstimator`, as we'll adopt the eltype of
# `Λ` anyway.

"""
    WoodburyEstimator(loss::LossFunction, rank::Integer;
                      σ²::Union{Real,Nothing}=nothing, corrected::Bool=false)

Specify that covariance matrices should be estimated using a "spiked" covariance model

    Σ = σ²I + U * Λ * U'

`loss` is either a [`NormLossCov`](@ref) or [`StatLossCov`](@ref) object, which specifies the
loss function for which the estimated covariance will be optimal. `rank` is the maximum
number of eigenvalues `Λ` to retain in the model. Optionally, one may specify `σ²` directly,
or it can be estimated from the data matrix (`σ²=nothing`). Set `corrected=true` to use
the unbiased estimator of the variance.
"""
struct WoodburyEstimator{L<:LossFunction} <: CovarianceEstimator
    loss::L
    rank::Int
    σ²::Union{Real,Nothing} # common diagonal variance, `nothing` indicates unknown
    corrected::Bool
end
WoodburyEstimator(loss::LossFunction, rank::Integer; σ²::Union{Real,Nothing}=nothing, corrected::Bool=false) =
    WoodburyEstimator(loss, rank, σ², corrected)

"""
    cov(estimator::WoodburyEstimator, X::AbstractMatrix, weights::FrequencyWeights...; dims::Int=1, mean=nothing, UsV=nothing)

Estimate the covariance matrix from the data matrix `X` using a "spiked" covariance model

    Σ = σ²I + U * Λ * U',

where `U` is a low-rank matrix of eigenvectors and `Λ` is a diagonal matrix.

Reference:
    Donoho, D.L., Gavish, M. and Johnstone, I.M., 2018.
    Optimal shrinkage of eigenvalues in the spiked covariance model. Annals of statistics, 46(4), p.1742.

When `σ²` is not supplied in `estimator`, it is calculated from the residuals `X - X̂`, where `X̂` is the
low-rank approximation of `X` used to generate `U` and `Λ`.

If `X` is too large to manipulate in memory, you can pass `UsV = (U, s, V)` (a truncated SVD of `X - mean(X; dims)`)
and then `X` will only be used compute the dimensionality and number of observations. This requires that you
specify `estimator.σ²`.
"""
function cov(estimator::WoodburyEstimator,  X::AbstractMatrix{<:Real}, weights::FrequencyWeights...;
             dims::Int=1, mean=nothing, UsV = nothing)
    # Argument validation
    dims ∈ (1, 2) || throw(ArgumentError("Argument dims can only be 1 or 2 (given: $dims)"))
    p = size(X, 3 - dims)
    p >= estimator.rank || throw(ArgumentError("Argument rank (got $(estimator.rank)) must be less than the number of observations (size(X, dims)=$(size(X, dims)))"))
    wn = totalweight(size(X, dims), weights...)

    local ΔX
    U, s, V = if UsV === nothing
        if mean === nothing
            mean = Statistics.mean(X, weights...; dims=dims)
        end
        # Compute the low-rank approximation of the centered data matrix
        ΔX = weightedX(X .- mean, weights...; dims=dims)
        tsvd(ΔX, estimator.rank)
    else
        UsV
    end

    T = eltype(s)
    σ² = estimator.σ²
    σ² = if σ² === nothing
        ΔΔX = ΔX - U*Diagonal(s)*V'
        # The number of degrees of freedom is (number of observations minus the rank)*dimensionality
        nσ = (totalweight(size(X, dims), weights...) - estimator.rank) * size(X, 3-dims)
        sum(abs2, ΔΔX) / (nσ - estimator.corrected)
    else
        T(σ²)
    end::T     # fix inferrability (see note at top of file)

    # Ratio of dimensionality to number of observations (the principal parameter in Random Matrix Theory)
    γ = p / wn

    # Implement the optimal shrinkage algorithm
    λ_shrunk = shrink.(Ref(estimator.loss), s.^2 ./ wn, σ², γ)
    keep = (!iszero).(λ_shrunk)

    # Return the shrunk covariance matrix as a WoodburyMatrix
    return SymWoodbury(σ² * I(p), dims == 1 ? V[:, keep] : U[:, keep], Diagonal(λ_shrunk[keep]))
end

function shrink(loss::LossFunction, λ::Real, σ²::Real, γ::Real)
    # Implement the procedure on Donoho et al. (2018), p. 1758
    # We return the difference from σ², since that's already contained in the diagonal term
    λu = λ / σ²
    λ₊ = (1 + sqrt(γ))^2
    λu < λ₊ && return zero(σ²)
    # Calculate the "de-biased" eigenvalue ℓ (Eq. 1.10)
    λ′ = λu + 1 - γ
    ℓ = (λ′ + sqrt(λ′^2 - 4λu)) / 2
    # Calculate the cosine (Eq. 1.6)
    c = sqrt((1 - γ / (ℓ - 1)^2) / (1 + γ / (ℓ - 1)))
    # Calculate the sine
    s = sqrt(1 - c^2)
    # Apply the shrinker
    return σ² * (shrinker(loss, ℓ, c, s) - 1)
end

using BenchmarkTools
using Random
using CovarianceEstimation

const SUITE = BenchmarkGroup()

Random.seed!(1234)

const X10_100  = randn(15, 100)
const X100_100  = randn(100, 100)
const X100_1000  = randn(100, 1000)
const X100_10000  = randn(100, 10000)
const X1000_100  = randn(1000, 100)
const X1000_10000  = randn(1000, 10000)

matrices = [X10_100, X100_100, X100_1000, X100_10000, X1000_10000]
estimators = Dict(
    "Simple" => (ce = SimpleCovariance(), maxfeatures = 10000),
    "Linear constant correlation" => (ce = LinearShrinkage(ConstantCorrelation()), maxfeatures = 1000),
    "Linear diagonal unit variance" => (ce = LinearShrinkage(DiagonalUnitVariance()), maxfeatures = 1000),
    "Linear diagonal common variance" => (ce = LinearShrinkage(DiagonalCommonVariance()), maxfeatures = 1000),
    "Linear common covariance" => (ce = LinearShrinkage(CommonCovariance()), maxfeatures = 1000),
    "Linear diagonal unequal variance" => (ce = LinearShrinkage(DiagonalUnequalVariance()), maxfeatures = 1000),
    "Linear perfect positive correlation" => (ce = LinearShrinkage(PerfectPositiveCorrelation()), maxfeatures = 1000),
    "Linear RBLW" => (ce = LinearShrinkage(DiagonalCommonVariance(), :rblw), maxfeatures = 10000),
    "Linear OAS" => (ce = LinearShrinkage(DiagonalCommonVariance(), :oas), maxfeatures = 10000),
    "Analytical nonlinear shrinkage" => (ce = AnalyticalNonlinearShrinkage(), maxfeatures = 1000)
)

for (k, v) in estimators
    SUITE[k] = BenchmarkGroup()
    for m in matrices
        if size(m, 2) ≤ v[:maxfeatures]
            SUITE[k]["Size $(size(m))"] = @benchmarkable cov($v[:ce], $m)
        end
    end
end

# This is a Julia adaptation of the Matlab code from O. Ledoit and M. Wolf
# solely used to test our own implementation of their estimator.
# Their code was released under the BSD-2 license with the copyright notice
# below.
# https://www.econ.uzh.ch/en/people/faculty/wolf/publications.html#9

###########################################################################
# This file is released under the BSD 2-clause license.

# Copyright (c) 2014, Olivier Ledoit and Michael Wolf
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are
# met:
#
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright
# notice, this list of conditions and the following disclaimer in the
# documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
# IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
# THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
# EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
# LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
# SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
###########################################################################

using LinearAlgebra
using Statistics

# comments marked with a `#` come from their code
# comments marked with a `#<#>` are ours

function matlab_ledoitwolf_covcor(z)
    x = copy(z)

    # de-mean returns
    t, n  = size(x)
    meanx = mean(x, dims=1)
    x -= repeat(meanx, outer=(t, 1))

    # compute sample covariance matrix
    sample = (1/t) * (x'*x)

    # compute prior
    diagsample = diag(sample)
    sqrtvar = sqrt.(diagsample)

    sqrtvar_mat = repeat(sqrtvar, outer=(1, n))

    rBar = (sum(sample./(sqrtvar_mat .* sqrtvar_mat'))-n)/(n*(n-1))
    prior = rBar * sqrtvar_mat .* sqrtvar_mat'

    #<#> replace the diagonal
    prior -= Diagonal(diag(prior))
    prior += Diagonal(diagsample)

    #<#> compute optimal shrinkage

    # what we call pi-hat
    y = x.^2;
    phiMat = y'*y/t - 2*(x'*x) .* sample/t + sample.^2
    phi = sum(phiMat)

    # what we call rho-hat
    term1    = ((x.^3)'*x)/t
    help     = x'*x/t
    helpDiag = diag(help)
    term2    = repeat(helpDiag, outer=(1, n)) .* sample
    term3    = help .* repeat(diagsample, outer=(1, n))
    term4    = repeat(diagsample, outer=(1, n)) .* sample
    thetaMat = term1 - term2 - term3 + term4
    #<#> remove the diagonal
    thetaMat -= Diagonal(diag(thetaMat))
    rho       = sum(diag(phiMat)) + rBar*sum(sqrtvar'./sqrtvar.*thetaMat)

    # what we call gamma hat
    gamma = sum((sample - prior).^2)
    kappa = (phi - rho) / gamma
    shrinkage = max(0, min(1, kappa/t))

    part_results = Dict(
        "r̄" => rBar,
        "F" => prior,
        "shrinkage" => shrinkage,
        "kappa" => kappa,
        "gamma" => gamma,
        "lwcov" => shrinkage*prior + (1-shrinkage)*sample)

    return part_results
end

# see NOTE in reference_ledoitwolf.jl
# this comes from appendix D in http://www.econ.uzh.ch/static/wp/econwp264.pdf
# adapted to Julia and checked for match with Octave.
# NOTE: it was modified to make the case p < n with centering work:
# - lambda[max(1, p-n+2):p] instead of lambda[max(1, p-n+1):p]
# - vcat(dtilde0 * ones(p-n+1,1), dtilde1); instead of vcat(dtilde0 * ones(p-n+1,1), dtilde1);

using LinearAlgebra
using Statistics

function matlab_ledoitwolf_analytical_shrinkage(X)
    n, p = size(X);
    @assert n ≥ 12 "there must be more than 12 samples"
    sample = cov(SimpleCovariance(), X); # note centering is applied here
    lambda, u = eigen(sample)
    perm = sortperm(lambda)
    lambda = lambda[perm]

    u = u[:, perm]
    η = ifelse(p<n, n, n-1)
    lambda = lambda[max(1, p-η+1):p]
    L = repeat(lambda, outer=(1, min(p, η)))

    h = η^(-1/3)
    H = h*L';
    x = (L-L')./H;

    ftilde = (3/4/sqrt(5))*mean(max.(1 .- x.^2 ./5,0)./H, dims=2);
    Hftemp = (-3/10/pi)*x + (3/4/sqrt(5)/pi) * (1 .- x.^2 ./5) .* log.(abs.((sqrt(5) .- x) ./ (sqrt(5) .+ x)));
    Hftemp[abs.(x).==sqrt(5)] .= (-3/10/pi)*x[abs.(x).==sqrt(5)];
    Hftilde = mean(Hftemp./H, dims=2);

    if p <= η
        dtilde = lambda ./ ((pi*(p/n)*lambda.*ftilde).^2 .+ (1 .- (p/n) .- pi*(p/n)*lambda.*Hftilde).^2);
    else
        Hftilde0 = (1/pi)*(3/10/h^2 + 3/4/sqrt(5)/h*(1-1/5/h^2) * log((1+sqrt(5)*h)/(1-sqrt(5)*h))) * mean(1 ./ lambda);
        dtilde0 = 1/(pi*(p-η)/η*Hftilde0);
        dtilde1 = lambda ./ (pi^2*lambda.^2 .* (ftilde.^2 .+ Hftilde.^2));
        dtilde = vcat(dtilde0 * ones(p-η,1), dtilde1);
    end

    u * (dtilde[:] .* u')
end

using CovarianceEstimation
using Statistics
using LinearAlgebra
using Test
using Random
using DelimitedFiles
using StatsBase

include("ref_lw_lshrink.jl")
include("ref_lw_nlshrink.jl")
include("legacy.jl")
Random.seed!(1234)

const CE = CovarianceEstimation

const X   = randn(3, 8)
const Z   = [2 -1 2; -1 2 -1; -1 -1 -1]
const X2s = [[1 0; 0 1; -1 0; 0 -1], [1 0; 0 1; 0 -1; -1 0]]
const Xa  = randn(5, 5)
const Xb  = randn(8, 3)
const Xc  = randn(15, 20)
const Xd  = randn(30, 50)
const Xe  = randn(50, 30)

const test_matrices = [X, Xa, Xb, Xc, Xd, Xe, Z]


function testTransposition(ce::CovarianceEstimator, X)
    @test cov(ce, X; dims=1) ≈ cov(ce, transpose(X); dims=2)
    @test cov(ce, X; dims=2) ≈ cov(ce, transpose(X); dims=1)
end

function testDims(ce::CovarianceEstimator, X)
    @test_throws ArgumentError cov(ce, X; dims=0)
    @test_throws ArgumentError cov(ce, X; dims=3)
end

function testUncorrelated(ce::CovarianceEstimator)
    for X2 ∈ X2s
        @test isdiag(cov(ce, X2))
    end
end

function testTranslation(ce::CovarianceEstimator, X)
    C1 = cov(ce, X)
    C2 = cov(ce, X .+ randn(1, size(X, 2)))
    @test C1 ≈ C2 atol = 1e-12 rtol = 1e-16
    C1t = cov(ce, X')
    C2t = cov(ce, X' .+ randn(1, size(X, 1)))
    @test C1t ≈ C2t atol = 1e-12 rtol = 1e-16
end

function _get_ref(name::AbstractString)
    path = endswith(pwd(), "CovarianceEstimation") ? "test" : ""
    return readdlm(joinpath(path, "test_matrices", "$name.csv"))
end

function _test_ref(ce::CovarianceEstimator, name::AbstractString, ref::AbstractString)
    X = _get_ref(name)
    ref_cov = _get_ref("$(name)_$ref")
    c = cov(ce, X)
    @test c ≈ ref_cov
    @test issymmetric(c)
end

function _test_refs(
    ce::CovarianceEstimator, names::AbstractVector{<:AbstractString}, ref::AbstractString,
)
    for name in names
        _test_ref(ce, name, ref)
    end
end

@testset "CovarianceEstimation" begin
    include("test_biweight.jl")
    include("test_linearshrinkage.jl")
    include("test_nonlinearshrinkage.jl")
    include("test_float32.jl")
    include("test_woodbury.jl")
end

using CovarianceEstimation
using Statistics
using LinearAlgebra
using Random:seed!
using DelimitedFiles
using ProgressMeter
using PyPlot

const CE = CovarianceEstimation

seed!(6312)

# dimensions

const np = (
    # fat matrices
    (15, 20), (20, 30), (20, 50), (100, 200),
    # tall matrices
    (20, 15), (30, 20), (50, 20), (200, 100),
    )

const LSE = LinearShrinkageEstimator

const estimators = Dict(
    # BASELINE ESTIMATORS
    "s_uncorr" => Simple(),
    "s_corr"   => Simple(corrected=true),
    # LINEAR SHRINKAGE, BASED ON UNCORRECTED SAMPLE COV
    "d1v_lw_uncorr"   => LSE(target=DiagonalUnitVariance(),
                              shrinkage=:lw),
    "d1v_ss_uncorr"   => LSE(target=DiagonalUnitVariance(),
                              shrinkage=:ss),
    "dcv_lw_uncorr"   => LSE(target=DiagonalCommonVariance(),
                              shrinkage=:lw),
    "dcv_ss_uncorr"   => LSE(target=DiagonalCommonVariance(),
                              shrinkage=:ss),
    "dcv_rblw_uncorr" => LSE(target=DiagonalCommonVariance(),
                              shrinkage=:rblw),
    "dcv_oas_uncorr"  => LSE(target=DiagonalCommonVariance(),
                              shrinkage=:oas),
    "duv_lw_uncorr"   => LSE(target=DiagonalUnequalVariance(),
                              shrinkage=:lw),
    "duv_ss_uncorr"   => LSE(target=DiagonalUnequalVariance(),
                              shrinkage=:ss),
    "ccov_lw_uncorr"  => LSE(target=CommonCovariance(),
                              shrinkage=:lw),
    "ccov_ss_uncorr"  => LSE(target=CommonCovariance(),
                              shrinkage=:ss),
    "ppc_lw_uncorr"   => LSE(target=PerfectPositiveCorrelation(),
                              shrinkage=:lw),
    "ppc_ss_uncorr"   => LSE(target=PerfectPositiveCorrelation(),
                              shrinkage=:ss),
    "ccor_lw_uncorr"  => LSE(target=ConstantCorrelation(),
                              shrinkage=:lw),
    "ccor_ss_uncorr"  => LSE(target=ConstantCorrelation(),
                              shrinkage=:ss),
    # LINEAR SHRINKAGE, BASED ON CORRECTED SAMPLE COV
    "d1v_lw_corr"   => LSE(target=DiagonalUnitVariance(),
                            shrinkage=:lw, corrected=true),
    "d1v_ss_corr"   => LSE(target=DiagonalUnitVariance(),
                            shrinkage=:ss, corrected=true),
    "dcv_lw_corr"   => LSE(target=DiagonalCommonVariance(),
                            shrinkage=:lw, corrected=true),
    "dcv_ss_corr"   => LSE(target=DiagonalCommonVariance(),
                            shrinkage=:ss, corrected=true),
    "dcv_rblw_corr" => LSE(target=DiagonalCommonVariance(),
                            shrinkage=:rblw, corrected=true),
    "dcv_oas_corr"  => LSE(target=DiagonalCommonVariance(),
                            shrinkage=:oas, corrected=true),
    "duv_lw_corr"   => LSE(target=DiagonalUnequalVariance(),
                            shrinkage=:lw, corrected=true),
    "duv_ss_corr"   => LSE(target=DiagonalUnequalVariance(),
                            shrinkage=:ss, corrected=true),
    "ccov_lw_corr"  => LSE(target=CommonCovariance(),
                            shrinkage=:lw, corrected=true),
    "ccov_ss_corr"  => LSE(target=CommonCovariance(),
                            shrinkage=:ss, corrected=true),
    "ppc_lw_corr"   => LSE(target=PerfectPositiveCorrelation(),
                            shrinkage=:lw, corrected=true),
    "ppc_ss_corr"   => LSE(target=PerfectPositiveCorrelation(),
                            shrinkage=:ss, corrected=true),
    "ccor_lw_corr"  => LSE(target=ConstantCorrelation(),
                            shrinkage=:lw, corrected=true),
    "ccor_ss_corr"  => LSE(target=ConstantCorrelation(),
                            shrinkage=:ss, corrected=true),
    # NONLINEAR SHRINKAGE, BASED ON UNCORRECTED SAMPLE COV
    "anshrink_uncorr" => AnalyticalNonlinearShrinkage(),
    # NONLINEAR SHRINKAGE, BASED ON CORRECTED SAMPLE COV
    "anshrink_uncorr" => AnalyticalNonlinearShrinkage()
    )

# warmup case
begin
    println("Warmup...")
    X = randn(15, 5)
    cov(Simple(), X)
    cov(Simple(corrected=true), X)
    @showprogress for (_, estimator) ∈ estimators
        cov(estimator, X)
    end
end

# number of time each experiment is ran
nrounds = 50

results = Dict{String, Float64}()

for (n, p) ∈ np
    # Generate a colouring matrix (cholesky of true cov)
    # the first randn allows for different amplitudes, the last one allows
    # for the various dimensions to have their variance on different scales
    L = randn() .* randn(p, p) .* randn(p)
    Σ = L * L'
    p2 = p^2
    println("Dims: $n x $p...")
    @showprogress for round ∈ 1:nrounds
        # generate a sample matrix
        X = randn(n, p) * L
        # estimate the covariance
        for (name, estimator) ∈ estimators
            results[name * "_$(n)x$(p)_$round"] =
                norm(cov(estimator, X) - Σ) / p2
        end
    end
end

reskeys = collect(keys(results))

results2 = Dict{String, NTuple{2, Float64}}()

# print results for each size and every estimator (cumbersome)
for (name, estimator) ∈ estimators
    for (n, p) ∈ np
        # find all the results that match
        matchkeys = filter(k -> occursin("$(name)_$(n)x$(p)_", k), reskeys)
        r = [results[key] for key ∈ matchkeys]
        med, iqr = mean(r), -(quantile(r, [0.75, 0.25])...)
        results2["$(name)_$(n)x$(p)_"] = (med, iqr)
    end
end

res2keys = collect(keys(results2))

# print best estimator per size
for (n, p) ∈ np
    matchkeys = filter(k -> occursin("_$(n)x$(p)_", k), res2keys)
    # dirty way to find the min
    name_best = ""
    val_best = Inf
    iqr_best = Inf
    for key ∈ matchkeys
        med, iqr = results2[key]
        if med < val_best
            name_best = key
            val_best = med
            iqr_best = iqr
        end
    end
    println("Size $(n)x$(p), best: $name_best ($val_best; $iqr_best)")
end


for (n, p) ∈ np
    figure()
    rkeys = filter(κ->occursin("$(n)x$(p)_", κ), res2keys)
    data = Vector{Vector{Float64}}(undef, length(rkeys))
    for (i, k) ∈ enumerate(rkeys)
        # find the results
        matchkeys = filter(κ -> occursin(k, κ), reskeys)
        data[i] = [results[κ] for κ ∈ matchkeys]
    end
    perm = sortperm(rkeys)
    boxplot(data[perm])
    title("Size: $(n)x$(p)")
    xticks(1:length(rkeys), rkeys[perm], rotation=90)
    tight_layout()
    savefig("docs/src/assets/mse_comp/bm_$(n)x$(p).png")
end

@testset "LinShrink: target F with LW (ref⭒) " begin
    lw = LinearShrinkage(ConstantCorrelation())
    testTransposition(lw, X)
    testUncorrelated(lw)
    testTranslation(lw, X)
    testDims(lw, X)
    for X̂ ∈ test_matrices
        ref_results = matlab_ledoitwolf_covcor(X̂)
        lwfixed = LinearShrinkage(ConstantCorrelation(), ref_results["shrinkage"])
        c = cov(lw, X̂); @test c ≈ ref_results["lwcov"]; @test issymmetric(c)
        c = cov(lwfixed, X̂); @test c ≈ ref_results["lwcov"]; @test issymmetric(c)
    end
end


@testset "LinShrink: target D with SS (ref⭒) " begin
    ## R Script used to compare:
    # require(corpcor)
    # tm1 = read.table("20x100.csv")
    # tm2 = read.table("100x20.csv")
    # tm3 = read.table("50x50.csv")
    # c1 = cov.shrink(tm1, lambda.var=0.0)
    # c2 = cov.shrink(tm2, lambda.var=0.0)
    # c3 = cov.shrink(tm3, lambda.var=0.0)

    ss = LinearShrinkage(target=DiagonalUnequalVariance(),
                                  shrinkage=:ss; corrected=true)

    _test_refs(ss, ["20x100", "100x20", "50x50"], "corpcor")
end


@testset "LinShrink: target ABCDE with LW    " begin
    # TARGET A
    lwa = LinearShrinkage(DiagonalUnitVariance())
    for X̂ ∈ test_matrices
        n, p = size(X̂)
        S = cov(SimpleCovariance(), X̂)
        Xtmp = centercols(X̂)
        shrinkage  = sum_var_sij(Xtmp, S, n)
        shrinkage /= sum((S-Diagonal(S)).^2) + sum((diag(S).-1).^2)
        shrinkage = clamp(shrinkage, 0.0, 1.0)
        c = cov(lwa, X̂); @test c ≈ (1.0-shrinkage) * S + shrinkage * I; @test issymmetric(c)
        lwafixed = LinearShrinkage(DiagonalUnitVariance(), shrinkage)
        c = cov(lwafixed, X̂); @test c ≈ (1.0 - shrinkage) * S + shrinkage * I
        @test issymmetric(c)
    end
    # TARGET B
    lwb = LinearShrinkage(DiagonalCommonVariance())
    for X̂ ∈ test_matrices
        n, p = size(X̂)
        S = cov(SimpleCovariance(), X̂)
        Xtmp = centercols(X̂)
        v = tr(S)/p
        F = v * I
        shrinkage  = sum_var_sij(Xtmp, S, n)
        shrinkage /= sum((S-Diagonal(S)).^2) + sum((diag(S).-v).^2)
        shrinkage = clamp(shrinkage, 0.0, 1.0)
        c = cov(lwb, X̂); @test c ≈ (1.0-shrinkage) * S + shrinkage * F; @test issymmetric(c)
        lwbfixed = LinearShrinkage(DiagonalCommonVariance(), shrinkage)
        c = cov(lwbfixed, X̂); @test c ≈ (1.0 - shrinkage) * S + shrinkage * F
        @test issymmetric(c)
    end
    # TARGET C
    lwc = LinearShrinkage(CommonCovariance())
    for X̂ ∈ test_matrices
        n, p = size(X̂)
        S = cov(SimpleCovariance(), X̂)
        Xtmp = centercols(X̂)
        v = tr(S)/p
        c = sum(S-Diagonal(S))/(p*(p-1))
        F = v * I + c * (ones(p, p) - I)
        shrinkage  = sum_var_sij(Xtmp, S, n)
        shrinkage /= sum(((S-Diagonal(S)) - c*(ones(p, p)-I)).^2) + sum((diag(S) .- v).^2)
        shrinkage = clamp(shrinkage, 0.0, 1.0)
        c = cov(lwc, X̂); @test c ≈ (1.0-shrinkage) * S + shrinkage * F; @test issymmetric(c)
        lwcfixed = LinearShrinkage(CommonCovariance(), shrinkage)
        c = cov(lwcfixed, X̂); @test  c ≈ (1.0-shrinkage) * S + shrinkage * F; @test issymmetric(c)
    end
    # TARGET D
    lwd = LinearShrinkage(DiagonalUnequalVariance())
    for X̂ ∈ test_matrices
        n, p = size(X̂)
        S = cov(SimpleCovariance(), X̂)
        Xtmp = centercols(X̂)
        F = Diagonal(S)
        shrinkage  = sum_var_sij(Xtmp, S, n, false; with_diag=false)
        shrinkage /= sum((S-Diagonal(S)).^2)
        shrinkage = clamp(shrinkage, 0.0, 1.0)
        c = cov(lwd, X̂); @test c ≈ (1.0-shrinkage) * S + shrinkage * F; @test issymmetric(c)
        lwdfixed = LinearShrinkage(DiagonalUnequalVariance(), shrinkage)
        c = cov(lwdfixed, X̂); @test c ≈ (1.0-shrinkage) * S + shrinkage * F; @test issymmetric(c)
    end
    # TARGET E
    lwe = LinearShrinkage(PerfectPositiveCorrelation())
    for X̂ ∈ test_matrices
        n, p = size(X̂)
        S = cov(SimpleCovariance(), X̂)
        Xtmp = centercols(X̂)
        d = diag(S)
        F = sqrt.(d*d')
        shrinkage  = sum_var_sij(Xtmp, S, n; with_diag=false)
        shrinkage -= CE.sum_fij(Xtmp, S, n, n)
        shrinkage /= sum((S - F).^2)
        shrinkage = clamp(shrinkage, 0.0, 1.0)
        c = cov(lwe, X̂); @test c ≈ (1.0-shrinkage) * S + shrinkage * F; @test issymmetric(c)
        lwefixed = LinearShrinkage(PerfectPositiveCorrelation(), shrinkage)
        c = cov(lwefixed, X̂); @test c ≈ (1.0-shrinkage) * S + shrinkage * F; @test issymmetric(c)
    end
end


@testset "LinShrink: target B with RBLW+OAS  " begin
    rblw = LinearShrinkage(DiagonalCommonVariance(), :rblw)
    testTransposition(rblw, X)
    testUncorrelated(rblw)
    testTranslation(rblw, X)
    testDims(rblw, X)

    oas = LinearShrinkage(DiagonalCommonVariance(), :oas)
    testTransposition(oas, X)
    testUncorrelated(oas)
    testTranslation(oas, X)
    testDims(oas, X)

    for X̂ ∈ test_matrices
        Ŝ_rblw = cov(rblw, X̂)
        Ŝ_oas  = cov(oas, X̂)

        X̂ = centercols(X̂)
        n, p = size(X̂)
        Ŝ    = cov(SimpleCovariance(), X̂)

        F_ref = tr(Ŝ)/p * I
        # https://arxiv.org/pdf/0907.4698.pdf eq 17
        λ_rblw_ref = ((n-2)/n*tr(Ŝ^2)+tr(Ŝ)^2)/((n+2)*(tr(Ŝ^2)-tr(Ŝ)^2/p))
        λ_rblw_ref = clamp(λ_rblw_ref, 0.0, 1.0)
        # https://arxiv.org/pdf/0907.4698.pdf eq 23
        λ_oas_ref = ((1-2/p)*tr(Ŝ^2)+tr(Ŝ)^2)/((n+1-2/p)*(tr(Ŝ^2)-tr(Ŝ)^2/p))
        λ_oas_ref = clamp(λ_oas_ref, 0.0, 1.0)

        c = cov(rblw, X̂); @test c ≈ CE.linshrink(F_ref, Ŝ, λ_rblw_ref); @test issymmetric(c)
        c = cov(oas, X̂); @test c ≈ CE.linshrink(F_ref, Ŝ, λ_oas_ref); @test issymmetric(c)

        rblw_fixed = LinearShrinkage(DiagonalCommonVariance(), λ_rblw_ref)
        oas_fixed = LinearShrinkage(DiagonalCommonVariance(), λ_oas_ref)
        c = cov(rblw_fixed, X̂); @test c ≈ CE.linshrink(F_ref, Ŝ, λ_rblw_ref)
        @test issymmetric(c)
        c = cov(oas_fixed, X̂); @test c ≈ CE.linshrink(F_ref, Ŝ, λ_oas_ref); @test issymmetric(c)
    end
end


@testset "LinShrink: all targets, std (SS)   " begin
    for target ∈ [
            DiagonalUnitVariance(),
            DiagonalCommonVariance(),
            DiagonalUnequalVariance(),
            CommonCovariance(),
            PerfectPositiveCorrelation(),
            ConstantCorrelation()
            ]
        #=
        :ss assumes that the shrinkage should be the same if the data
        matrix is standardised. This is what is tested.
        =#
        for corrected ∈ [false, true], X̂ ∈ test_matrices
            Xcs = X̂
            Xcs = centercols(Xcs)
            n = size(Xcs, 1)
            for i ∈ 1:size(Xcs, 2)
                Xcs[:, i] ./= sqrt(var(Xcs[:, i], corrected=corrected))
            end
            LSEss = LinearShrinkage(target, :ss, corrected=corrected)
            LSElw = LinearShrinkage(target, :lw, corrected=corrected)
            c = cov(LSEss, Xcs); @test c ≈ cov(LSElw, Xcs); @test issymmetric(c)
            # Adding a coordinate with no variance should not result in NaN entries
            Xcs = [Xcs zeros(n, 1)]
            LSEssdv0 = LinearShrinkage(target, :ss, corrected=corrected, drop_var0=true)
            LSElwdv0 = LinearShrinkage(target, :lw, corrected=corrected, drop_var0=true)
            c = cov(LSEssdv0, Xcs)
            @test all(isfinite, c); @test c ≈ cov(LSElwdv0, Xcs); @test issymmetric(c)
            # Weight types besides FrequencyWeights are not supported
            aw1 = AnalyticWeights(rand(size(Xcs, 1)))
            @test_throws ErrorException cov(LSEss, Xcs, aw1)
            @test_throws ErrorException cov(LSEss, Xcs, aw1; dims=2)
            @test_throws ErrorException cov(LSEss, Xcs, aw1; mean=nothing)
        end
    end
end

@testset "LinShrink: all targets, mean arg   " begin
    for target ∈ [
            DiagonalUnitVariance(),
            DiagonalCommonVariance(),
            DiagonalUnequalVariance(),
            CommonCovariance(),
            PerfectPositiveCorrelation(),
            ConstantCorrelation()
            ]
        for c ∈ [true, false], dim ∈ [1, 2], X̂ ∈ test_matrices[1:3]
            Xcs = X̂
            Xcs = centercols(Xcs)
            n = size(Xcs, dim)
            LSEss = LinearShrinkage(target, :ss, corrected=c)
            LSElw = LinearShrinkage(target, :lw, corrected=c)
            m = mean(cov(LSEss, Xcs, dims=dim, mean=nothing))
            c = cov(LSEss, Xcs, dims=dim, mean=mean(Xcs, dims=dim));
            @test c ≈ cov(LSEss, Xcs, dims=dim, mean=nothing); @test issymmetric(c)
            c = cov(LSElw, Xcs, dims=dim, mean=mean(Xcs, dims=dim));
            @test c ≈ cov(LSElw, Xcs, dims=dim, mean=nothing); @test issymmetric(c)
            if dim == 2
                meanvec = vec(mean(Xcs, dims=dim))
                @test cov(LSEss, Xcs, dims=dim, mean=meanvec) ≈ cov(LSEss, Xcs, dims=dim, mean=nothing)
                @test cov(LSElw, Xcs, dims=dim, mean=meanvec) ≈ cov(LSElw, Xcs, dims=dim, mean=nothing)
            end
            # weights
            w = FrequencyWeights(ones(n))
            c = cov(LSEss, Xcs, w; dims=dim, mean=mean(Xcs, w; dims=dim));
            @test c ≈ cov(LSEss, Xcs; dims=dim, mean=nothing)
            n2 = n ÷ 2
            if n2 > 1
                w = FrequencyWeights([ones(n2); zeros(n-n2)])
                meanvec = mean(Xcs, w; dims=dim)
                for mn in (meanvec, nothing), ce in (LSEss, LSElw)
                    c = cov(ce, Xcs, w; dims=dim, mean=mn);
                    @test c ≈ cov(ce, dim == 1 ? Xcs[1:n2, :] : Xcs[:, 1:n2]; dims=dim, mean=nothing)
                end
            end
        end
    end
end

using CairoMakie
using CairoMakie.Colors

# Attempt to match the colors in Fig 3. of Donoho et al. (2018)
const colors = [colorant"green1", colorant"cyan", colorant"steelblue1", colorant"blue", colorant"purple3", colorant"magenta", colorant"violetred"]

shrink(loss, λ) = CovarianceEstimation.shrink(loss, λ, 1, 1) + 1   # +1 because that's incorporated into the Woodbury σ² term
function ℓ(λ, γ=1)
    λ′ = λ + 1 - γ
    return (λ′ + sqrt(λ′^2 - 4λ)) / 2
end

λ = range(4, 9, length=101)

fig = Figure(size = (800, 800))#, font = "CMU Serif")

# L2 norm
ax = Axis(fig[1, 1], xlabel="λ", ylabel="η(λ)", title="norm=:L2, γ=1")
for i = 1:7
    i ∈ (5, 7) && continue
    loss = NormLossCov(:L2, i)
    lines!(ax, λ, shrink.(Ref(loss), λ); color=colors[i], label="F+$i")
end
lines!(ax, λ, λ, color=:red, linestyle=:dash, label="η(λ) = λ")
lines!(ax, λ, ℓ.(λ), color=:black, linestyle=:dash, label="ℓ(λ)")
ylims!(ax, (1, 9))
axislegend(ax, position=:lt)

# L1 norm
ax = Axis(fig[2, 1], xlabel="λ", ylabel="η(λ)", title="norm=:L1, γ=1")
for i = 1:7
    i ∈ (5, 7) && continue
    loss = NormLossCov(:L1, i)
    lines!(ax, λ, shrink.(Ref(loss), λ); color=colors[i], label="N+$i")
end
lines!(ax, λ, λ, color=:red, linestyle=:dash, label="η(λ) = λ")
lines!(ax, λ, ℓ.(λ), color=:black, linestyle=:dash, label="ℓ(λ)")
ylims!(ax, (1, 9))
axislegend(ax, position=:lt)

# Linf norm
ax = Axis(fig[1, 2], xlabel="λ", ylabel="η(λ)", title="norm=:Linf, γ=1")
for i = 1:7
    i ∈ (3, 4, 5, 7) && continue
    loss = NormLossCov(:Linf, i)
    lines!(ax, λ, shrink.(Ref(loss), λ); color=colors[i], label="O+$i")
end
lines!(ax, λ, λ, color=:red, linestyle=:dash, label="η(λ) = λ")
lines!(ax, λ, ℓ.(λ), color=:black, linestyle=:dash, label="ℓ(λ)")
ylims!(ax, (1, 9))
axislegend(ax, position=:lt)

# Statistical losses
ax = Axis(fig[2, 2], xlabel="λ", ylabel="η(λ)", title="Statistical losses (γ=1)")
lines!(ax, λ, shrink.(Ref(StatLossCov(:st)), λ); color=colors[1], label="Stein")
lines!(ax, λ, shrink.(Ref(StatLossCov(:ent)), λ); color=colors[2], label="Entropy")
lines!(ax, λ, shrink.(Ref(StatLossCov(:div)), λ); color=colors[3], label="Divergence")
lines!(ax, λ, shrink.(Ref(StatLossCov(:aff)), λ); color=colors[6], label="Affine")
lines!(ax, λ, shrink.(Ref(StatLossCov(:fre)), λ); color=colors[4], label="Frechet")
lines!(ax, λ, λ, color=:red, linestyle=:dash, label="η(λ) = λ")
lines!(ax, λ, ℓ.(λ), color=:black, linestyle=:dash, label="ℓ(λ)")
ylims!(ax, (1, 9))
axislegend(ax, position=:lt)

save(joinpath(pkgdir(CovarianceEstimation), "docs", "src", "assets", "donoho_fig3.png"), fig)

# Public Documentation

Documentation for `CovarianceEstimation.jl`'s public interface.

See [Internal Documentation](@ref) for internal package docs.

## Contents

```@contents
Pages = ["public.md"]
```

## Index

```@index
Pages = ["public.md"]
```

## Public Interface

```@docs
cov
LinearShrinkage
DiagonalUnitVariance
DiagonalCommonVariance
DiagonalUnequalVariance
CommonCovariance
PerfectPositiveCorrelation
ConstantCorrelation
AnalyticalNonlinearShrinkage
BiweightMidcovariance
NormLossCov
StatLossCov
WoodburyEstimator
```

# Internal Documentation

Documentation for `CovarianceEstimation.jl`'s internal methods.

See [Public Documentation](@ref) for public package docs.

## Contents

```@contents
Pages = ["internals.md"]
```

## Index

```@index
Pages = ["internals.md"]
```

## Internals

```@docs
CovarianceEstimation.epanechnikov
CovarianceEstimation.epanechnikov_HT1
CovarianceEstimation.epanechnikov_HT2
CovarianceEstimation.rescale
CovarianceEstimation.rescale!
CovarianceEstimation.uccov
CovarianceEstimation.sumij
CovarianceEstimation.sumij2
CovarianceEstimation.sum_fij
CovarianceEstimation.linear_shrinkage
CovarianceEstimation.analytical_nonlinear_shrinkage
```

# Methods

## Notations

In these docs, $X$ denotes an $n\times p$ data matrix describing $n$ observations with $p$ features (variables) and possibly $p > n$.
For most estimators, the matrix is assumed to have entries in $\mathbb R$.

!!! note

    While in the docs we assume that the rows of $X$ correspond to observations and the columns to features, in the code you can specify this using the `dims` keyword with `dims=1` being the default whereas `dims=2` will take rows as features and columns as observations.

We will write $X_c$ the *centered* matrix i.e. where each column sums up to zero.
We will also write $X_s$ the *standardised* matrix i.e. where each column not only sums up to zero but is scaled to have sample variance one.
Finally, we will write $S$ the standard sample covariance estimator (see below) of size $p\times p$ and $D$ the diagonal matrix matching the diagonal of $S$.

Note that the sample variance and covariance can be corrected or uncorrected (and this can be specified in the code).
In order to avoid having to specify this everywhere in the document, it is useful to introduce a last symbol: $\kappa$ which is either set to $n$ (uncorrected case) or $(n-1)$ (corrected case).

With these notations we can write:

```math
\begin{aligned}
    S &= \kappa^{-1}X_c^T X_c\\
    D_{ij} &= S_{ij}\mathbf 1_{[i=j]}\\
    X_s &= X_c D^{-1/2}
\end{aligned}
```

## Simple estimator

The standard covariance estimator is easily obtained via the equation above.
It can be specified with the constructor `SimpleCovariance` which can take a named argument `corrected` (either `false` (default) or `true`).

```@example
using CovarianceEstimation # hide
using Random # hide
Random.seed!(1)
n, p = 5, 7
X = randn(n, p)
# corrected covariance
S = cov(SimpleCovariance(corrected=true), X)
# we can also manually compute it and compare
Xc = (X .- sum(X, dims=1)/n) # centering
κ = n-1 # correction factor
S ≈ (Xc'*Xc)/κ
```

## Linear shrinkage estimators

Linear shrinkage estimators correspond to covariance estimators of the form

```math
\hat\Sigma = (1-\lambda)S + \lambda F
```

where $F$ is a *target* matrix of appropriate dimensions, $\lambda\in[0,1]$ is a shrinkage intensity and $S$ is the sample covariance estimator.
There are several standard targets that can be used, a simple example being the identity matrix.

The shrinkage intensity $\lambda$ can be specified manually or computed automatically.
Depending on the target, different approaches are implemented to compute a good intensity such as, for example, the Ledoit-Wolf optimal intensity (which is the default intensity if you don't specify it).

You can read more on the targets that can be used and the corresponding automatic intensities [here](@ref lshrink).

Here is an example using the identity matrix as a target and automatic shrinkage intensity (Ledoit-Wolfe):

```@example
using CovarianceEstimation # hide
using Random # hide
Random.seed!(1)
n, p = 2, 3
X = randn(n, p)
target = DiagonalUnitVariance()
shrinkage = :lw # Ledoit-Wolf optimal shrinkage
method = LinearShrinkage(target, shrinkage)
cov(method, X)
```

You can also specify the intensity manually:

```@example
using CovarianceEstimation # hide
using Random # hide
Random.seed!(1) # hide
n, p = 2, 3 # hide
X = randn(n, p) # hide
target = DiagonalUnitVariance() # hide
shrinkage = 0.8
method2 = LinearShrinkage(target, shrinkage)
cov(method2, X)
```

[Read more on linear shrinkage estimators...](@ref lshrink)

## Nonlinear shrinkage estimators

[Read more on nonlinear shrinkage estimators...](@ref nlshrink)

## Biweight midcovariance

The biweight midcovariance is a covariance estimator that is resilient to outliers.
A full description of the technique is included on [`BiweightMidcovariance`](@ref).

```@example
using CovarianceEstimation # hide
using Distributions # hide
using Random # hide
Random.seed!(1)
n, p = 10, 3
X = rand(TDist(3), (n, p))  # Moderately heavy-tailed data
cov(BiweightMidcovariance(), X)
```

The two controllable parameters are the keyword arguments `c` and `modify_sample_size`, whose purpose is described in the docstring.

## Comparing estimators

You may want to look at our simple [comparison of covariance estimators](@ref msecomp) which compares the MSE of the various estimators in a range of situations.
Long story short, the `LinearShrinkageEstimator` with `DiagonalUnequalVariance` target performs well in the case $n<p$ though most other estimators don't fare too badly in comparison.
In the case $n>p$, the nonlinear shrinkage method does very well (though it is more expensive to compute).

# [MSE Comparison](@id msecomp)

Below are results obtained with a variety of data matrices of dimensions $n\times p$.
For each pair of dimension, 50 covariance matrices are generated with associated sample data matrices.
The covariance obtained with the different estimators are then compared to the ground-truth and the MSE is reported.

| Abbreviation | Method |
| ---- | ---- |
| `anshrink` | analytical nonlinear shrinkage |
| `ccor` | LSE with constant correlation target |
| `ccov` | LSE with constant covariance target |
| `d1v`  | LSE with identity target |
| `dcv`  | LSE with diagonal common variance target |
| `duv`  | LSE with diagonal unequal variance target |
| `ppc`  | LSE with perfect positive correlation target |
| `s`  | Simple estimator (baseline) |
| `_lw`  | uses ledoit-wolf shrinkage |
| `_ss`  | uses schaffer-strimmer shrinkage |
| `_oas`  | uses oracle approximating shrinkage |
| `_rblw`  | uses rao-blackwellised ledoit-wolf shrinkage |


## Fat matrices

![](../assets/mse_comp/bm_15x20.png)
![](../assets/mse_comp/bm_20x30.png)
![](../assets/mse_comp/bm_20x50.png)
![](../assets/mse_comp/bm_100x200.png)

## Tall matrices

![](../assets/mse_comp/bm_20x15.png)
![](../assets/mse_comp/bm_30x20.png)
![](../assets/mse_comp/bm_50x20.png)
![](../assets/mse_comp/bm_200x100.png)

# CovarianceEstimation.jl

*Lightweight robust covariance estimation in Julia.*

A package for robustly estimating covariance matrices of real-valued data.

## Package Features

- Standard corrected and uncorrected covariance estimators,
- Linear and Nonlinear shrinkage estimators, including estimators for covariance matrices too large to store in dense form
- Focus on speed and lightweight dependencies

## Manual outline

```@contents
Pages = ["man/methods.md", "man/lshrink.md", "man/nlshrink.md", "man/msecomp.md"]
```

## Library Outline

```@contents
Pages = ["lib/public.md", "lib/internals.md"]
```

### [Index](@id main-index)

```@index
Pages = ["lib/public.md"]
```

# [Nonlinear shrinkage estimators](@id nlshrink)

Nonlinear shrinkage estimators correspond to covariance estimators based on the eigendecomposition of the sample matrix:

```
F = eigen(X)
# ... (transformation of eigenvalues)
F.U*(d̃ .* F.U') # d̃ is a vector of transformed eigenvalues
```

Currently, there are two flavors of analytical nonlinear shrinkage:
- [`AnalyticalNonlinearShrinkage`](@ref) is recommended in cases where the covariance matrix can be stored as a dense matrix
- for cases where the covariance matrix is too large to handle in dense form, [`WoodburyEstimator`](@ref) models the covariance matrix as

    Σ = σ²I + U * Λ * U'

where `σ` is a scalar, `I` is the identity matrix, `U` is a low-rank semi-orthogonal matrix, and `Λ` is diagonal.
One can readily compute with this representation via the [Woodbury matrix identity](https://en.wikipedia.org/wiki/Woodbury_matrix_identity) and the [WoodburyMatrices package](https://github.com/JuliaLinearAlgebra/WoodburyMatrices.jl).
This formulation approximates the covariance matrix as if all but a few (largest) eigenvalues are equal to `σ²`.
A [truncated singular value decomposition](https://github.com/JuliaLinearAlgebra/TSVD.jl) of the data matrix is
performed and the corresponding eigenvalues are shrunk by optimal methods for a wide variety of loss functions:

- [`NormLossCov`](@ref) allows you to specify that you want to minimize some notion of loss against the "true" covariance matrix
- [`StatLossCov`](@ref) allows you to optimize for certain specific statistical outcomes, e.g., optimizing the accuracy of Mahalanobis distances.

The eigenvalue shrinkage function is plotted for all choices below:

![Donoho et al Fig 3](../assets/donoho_fig3.png)

For complete details, see:

Donoho, D.L., Gavish, M. and Johnstone, I.M., 2018.
Optimal shrinkage of eigenvalues in the spiked covariance model. Annals of statistics, 46(4), p.1742.

# [Linear shrinkage estimators](@id lshrink)

Linear shrinkage estimators correspond to covariance estimators of the form

```math
\hat\Sigma = (1-\lambda)S + \lambda F
```

where $F$ is a *target* matrix of appropriate dimensions, $\lambda\in[0,1]$ is a shrinkage intensity and $S$ is the sample covariance estimator (corrected or uncorrected depending on the `corrected` keyword).

## Targets and intensities

There are several standard target matrices (denoted by $F$) that can be used (we follow here the notations and naming conventions of [Schaffer & Strimmer 2005](https://strimmerlab.github.io/publications/journals/shrinkcov2005.pdf)):


| Target name | $F_{ii}$     | $F_{ij}$ ($i\neq j$) | Comment   |
| ------------ | ------------ | ------------         | --------- |
| `DiagonalUnitVariance`| $1$ | $0$ | $F = \mathbf I$ |
| `DiagonalCommonVariance`| $v$ | 0 | $F = v\mathbf I$ |
| `DiagonalUnequalVariance` | $S_{ii}$ | 0 | $F = \mathrm{diag}(S)$, very common |
| `CommonCovariance` | $v$ | $c$ | |
| `PerfectPositiveCorrelation` | $S_{ii}$ | $\sqrt{S_{ii}S_{jj}}$ | |
| `ConstantCorrelation` | $S_{ii}$ | $\overline{r}\sqrt{S_{ii}S_{jj}}$ | used in [Ledoit & Wolf 2004](http://www.ledoit.net/honey.pdf) |


where $ v = \mathrm{tr}(S)/p $ is the average variance, $c = \sum_{i\neq j} S_{ij}/(p(p-1))$ is the average of off-diagonal terms of $S$ and $\overline{r}$ is the average of sample correlations (see [Schaffer & Strimmer 2005](https://strimmerlab.github.io/publications/journals/shrinkcov2005.pdf)).

For each of these targets, an optimal shrinkage intensity $\lambda^\star$ can be computed.
A standard approach is to apply the Ledoit-Wolf formula (`shrinkage=:lw`, see [Ledoit & Wolf 2004](http://www.ledoit.net/honey.pdf)) though there are some variants that can be applied too.
Notably, Schaffer & Strimmer's variant (`shrinkage=:ss`) will ensure that the $\lambda^\star$ computed is the same for $X_c$ (the centered data matrix) as for $X_s$ (the standardised data matrix).
See [Schaffer & Strimmer 2005](https://strimmerlab.github.io/publications/journals/shrinkcov2005.pdf).

Chen's variant includes a Rao-Blackwellised estimator (`shrinkage=:rblw`) and an Oracle-Approximating one (`shrinkage=:oas`) for the `DiagonalCommonVariance` target.
See [Chen, Wiesel, Eldar & Hero 2010](https://arxiv.org/pdf/0907.4698.pdf).
